searchNodes=[{"doc":"Pre-trained Axon models for easy inference and boosted training. Bumblebee provides state-of-the-art, configurable Axon models. On top of that, it streamlines the process of loading pre-trained models by integrating with Hugging Face Hub and 🤗 Transformers . Usage You can load one of the supported models by specifying the model repository: { :ok , model_info } = Bumblebee . load_model ( { :hf , &quot;bert-base-uncased&quot; } ) { :ok , tokenizer } = Bumblebee . load_tokenizer ( { :hf , &quot;bert-base-uncased&quot; } ) Then you are ready to make predictions: inputs = Bumblebee . apply_tokenizer ( tokenizer , &quot;Hello Bumblebee!&quot; ) outputs = Axon . predict ( model_info . model , model_info . params , inputs ) Tasks On top of bare models, Bumblebee provides a number of &quot;servings&quot; that act as end-to-end pipelines for specific tasks. serving = Bumblebee.Text . fill_mask ( model_info , tokenizer ) Nx.Serving . run ( serving , &quot;The capital of [MASK] is Paris.&quot; ) #=&gt; %{ #=&gt; predictions: [ #=&gt; %{score: 0.9279842972755432, token: &quot;france&quot;}, #=&gt; %{score: 0.008412551134824753, token: &quot;brittany&quot;}, #=&gt; %{score: 0.007433671969920397, token: &quot;algeria&quot;}, #=&gt; %{score: 0.004957548808306456, token: &quot;department&quot;}, #=&gt; %{score: 0.004369721747934818, token: &quot;reunion&quot;} #=&gt; ] #=&gt; } As you can see the serving takes care of pre-processing the text input, runs the model and also post-processes its output into more structured data. In the above example we run serving on the fly, however for production usage you can start serving as a process and it will automatically batch requests from multiple clients. Processing inputs in batches is usually much more efficient, since it can take advantage of parallel capabilities of the target device, which is particularly relevant in case of GPU. For more details read the Nx.Serving docs. For more examples see the Examples notebook. Note The models are generally large, so make sure to configure an efficient Nx backend, such as EXLA or Torchx .","ref":"Bumblebee.html","title":"Bumblebee","type":"module"},{"doc":"Featurizes input with the given featurizer. Options :defn_options - the options for JIT compilation. Note that this is only relevant for featurizers implemented with Nx. Defaults to [] Examples featurizer = Bumblebee . configure ( Bumblebee.Vision.ConvNextFeaturizer ) { :ok , img } = StbImage . read_file ( path ) inputs = Bumblebee . apply_featurizer ( featurizer , [ img ] )","ref":"Bumblebee.html#apply_featurizer/3","title":"Bumblebee.apply_featurizer/3","type":"function"},{"doc":"Tokenizes and encodes input with the given tokenizer. Options :add_special_tokens - whether to add special tokens. Defaults to true :pad_direction - the padding direction, either :right or :left . Defaults to :right :return_attention_mask - whether to return attention mask for encoded sequence. Defaults to true :return_token_type_ids - whether to return token type ids for encoded sequence. Defaults to true :return_special_tokens_mask - whether to return special tokens mask for encoded sequence. Defaults to false :return_offsets - whether to return token offsets for encoded sequence. Defaults to false :length - applies fixed length padding or truncation to the given input if set Examples tokenizer = Bumblebee . load_tokenizer ( { :hf , &quot;bert-base-uncased&quot; } ) inputs = Bumblebee . apply_tokenizer ( tokenizer , [ &quot;The capital of France is [MASK].&quot; ] )","ref":"Bumblebee.html#apply_tokenizer/3","title":"Bumblebee.apply_tokenizer/3","type":"function"},{"doc":"Builds an Axon model according to the given specification. Example spec = Bumblebee . configure ( Bumblebee.Vision.ResNet , architecture : :base , embedding_size : 128 ) model = Bumblebee . build_model ( spec )","ref":"Bumblebee.html#build_model/1","title":"Bumblebee.build_model/1","type":"function"},{"doc":"Returns the directory where downloaded files are stored.","ref":"Bumblebee.html#cache_dir/0","title":"Bumblebee.cache_dir/0","type":"function"},{"doc":"Builds or updates a configuration object with the given options. Expects a configuration struct or a module supporting configuration. These are usually configurable: model specification ( Bumblebee.ModelSpec ) featurizer ( Bumblebee.Featurizer ) scheduler ( Bumblebee.Scheduler ) Examples To build a new configuration, pass a module: featurizer = Bumblebee . configure ( Bumblebee.Vision.ConvNextFeaturizer ) spec = Bumblebee . configure ( Bumblebee.Vision.ResNet , architecture : :for_image_classification ) Similarly, you can update an existing configuration: featurizer = Bumblebee . configure ( featurizer , resize_method : :bilinear ) spec = Bumblebee . configure ( spec , embedding_size : 128 )","ref":"Bumblebee.html#configure/2","title":"Bumblebee.configure/2","type":"function"},{"doc":"Loads featurizer from a model repository. Options :module - the featurizer module. By default it is inferred from the preprocessor configuration file, if that is not possible, it must be specified explicitly Examples { :ok , featurizer } = Bumblebee . load_featurizer ( { :hf , &quot;microsoft/resnet-50&quot; } )","ref":"Bumblebee.html#load_featurizer/2","title":"Bumblebee.load_featurizer/2","type":"function"},{"doc":"Loads generation config from a model repository. Generation config includes a number of model-specific properties, so it is usually best to load the config and further configure, rather than building from scratch. See Bumblebee.Text.GenerationConfig for all the available options. Examples { :ok , generation_config } = Bumblebee . load_generation_config ( { :hf , &quot;gpt2&quot; } ) generation_config = Bumblebee . configure ( generation_config , max_new_tokens : 10 )","ref":"Bumblebee.html#load_generation_config/1","title":"Bumblebee.load_generation_config/1","type":"function"},{"doc":"Loads a pre-trained model from a model repository. Options :spec - the model specification to use when building the model. By default the specification is loaded using load_spec/2 :module - the model specification module. By default it is inferred from the configuration file, if that is not possible, it must be specified explicitly :architecture - the model architecture, must be supported by :module . By default it is inferred from the configuration file :params_filename - the file with the model parameters to be loaded :log_params_diff - whether to log missing, mismatched and unused parameters. By default diff is logged only if some parameters cannot be loaded :backend - the backend to allocate the tensors on. It is either an atom or a tuple in the shape {backend, options} Examples By default the model type is inferred from configuration, so loading is as simple as: { :ok , resnet } = Bumblebee . load_model ( { :hf , &quot;microsoft/resnet-50&quot; } ) %{ model : model , params : params , spec : spec } = resnet You can explicitly specify a different architecture, in which case matching parameters are still loaded: { :ok , resnet } = Bumblebee . load_model ( { :hf , &quot;microsoft/resnet-50&quot; } , architecture : :base ) To further customize the model, you can also pass the specification: { :ok , spec } = Bumblebee . load_spec ( { :hf , &quot;microsoft/resnet-50&quot; } ) spec = Bumblebee . configure ( spec , num_labels : 10 ) { :ok , resnet } = Bumblebee . load_model ( { :hf , &quot;microsoft/resnet-50&quot; } , spec : spec )","ref":"Bumblebee.html#load_model/2","title":"Bumblebee.load_model/2","type":"function"},{"doc":"Loads scheduler from a model repository. Options :module - the scheduler module. By default it is inferred from the scheduler configuration file, if that is not possible, it must be specified explicitly Examples { :ok , scheduler } = Bumblebee . load_scheduler ( { :hf , &quot;CompVis/stable-diffusion-v1-4&quot; , subdir : &quot;scheduler&quot; } )","ref":"Bumblebee.html#load_scheduler/2","title":"Bumblebee.load_scheduler/2","type":"function"},{"doc":"Loads model specification from a model repository. Options :module - the model specification module. By default it is inferred from the configuration file, if that is not possible, it must be specified explicitly :architecture - the model architecture, must be supported by :module . By default it is inferred from the configuration file Examples { :ok , spec } = Bumblebee . load_spec ( { :hf , &quot;microsoft/resnet-50&quot; } ) You can explicitly specify a different architecture: { :ok , spec } = Bumblebee . load_spec ( { :hf , &quot;microsoft/resnet-50&quot; } , architecture : :base )","ref":"Bumblebee.html#load_spec/2","title":"Bumblebee.load_spec/2","type":"function"},{"doc":"Loads tokenizer from a model repository. Options :module - the tokenizer module. By default it is inferred from the configuration files, if that is not possible, it must be specified explicitly Examples { :ok , tokenizer } = Bumblebee . load_tokenizer ( { :hf , &quot;bert-base-uncased&quot; } )","ref":"Bumblebee.html#load_tokenizer/2","title":"Bumblebee.load_tokenizer/2","type":"function"},{"doc":"Initializes state for a new scheduler loop. Returns a pair of {state, timesteps} , where state is an opaque container expected by scheduler_step/4 and timesteps is a sequence of subsequent timesteps for model forward pass. Note that the number of timesteps may not match num_steps exactly. num_steps parameterizes sampling points, however depending on the method, sampling certain points may require multiple forward passes of the model and each element in timesteps corresponds to a single forward pass.","ref":"Bumblebee.html#scheduler_init/3","title":"Bumblebee.scheduler_init/3","type":"function"},{"doc":"Predicts sample at the previous timestep using the given scheduler. Takes the current sample and prediction (usually noise) returned by the model at the current timestep. Returns {state, prev_sample} , where state is the updated scheduler loop state and prev_sample is the predicted sample at the previous timestep. Note that some schedulers require several forward passes of the model (and a couple calls to this function) to make an actual prediction for the previous sample.","ref":"Bumblebee.html#scheduler_step/4","title":"Bumblebee.scheduler_step/4","type":"function"},{"doc":"A model together with its state and metadata.","ref":"Bumblebee.html#t:model_info/0","title":"Bumblebee.model_info/0","type":"type"},{"doc":"A location to fetch model files from. Can be either: {:hf, repository_id} - the repository on Hugging Face. Options may be passed as the third element: :revision - the specific model version to use, it can be any valid git identifier, such as branch name, tag name, or a commit hash :cache_dir - the directory to store the downloaded files in. Defaults to the standard cache location for the given operating system. You can also configure it globally by setting the BUMBLEBEE_CACHE_DIR environment variable :offline - if true , only cached files are accessed and missing files result in an error. You can also configure it globally by setting the BUMBLEBEE_OFFLINE environment variable to true :auth_token - the token to use as HTTP bearer authorization for remote files :subdir - the directory within the repository where the files are located {:local, directory} - the directory containing model files","ref":"Bumblebee.html#t:repository/0","title":"Bumblebee.repository/0","type":"type"},{"doc":"High-level tasks related to audio processing.","ref":"Bumblebee.Audio.html","title":"Bumblebee.Audio","type":"module"},{"doc":"Builds serving for speech-to-text generation. The serving accepts speech_to_text_input/0 and returns speech_to_text_output/0 . A list of inputs is also supported. Options :seed - random seed to use when sampling. By default the current timestamp is used :compile - compiles all computations for predefined input shapes during serving initialization. Should be a keyword list with the following keys: :batch_size - the maximum batch size of the input. Inputs are optionally padded to always match this batch size It is advised to set this option in production and also configure a defn compiler using :defn_options to maximally reduce inference time. :defn_options - the options for JIT compilation. Defaults to [] Examples { :ok , whisper } = Bumblebee . load_model ( { :hf , &quot;openai/whisper-tiny&quot; } ) { :ok , featurizer } = Bumblebee . load_featurizer ( { :hf , &quot;openai/whisper-tiny&quot; } ) { :ok , tokenizer } = Bumblebee . load_tokenizer ( { :hf , &quot;openai/whisper-tiny&quot; } ) { :ok , generation_config } = Bumblebee . load_generation_config ( { :hf , &quot;openai/whisper-tiny&quot; } ) serving = Bumblebee.Audio . speech_to_text ( whisper , featurizer , tokenizer , generation_config , defn_options : [ compiler : EXLA ] ) Nx.Serving . run ( serving , { :file , &quot;/path/to/audio.wav&quot; } ) #=&gt; %{results: [%{text: &quot;There is a cat outside the window.&quot;}]}","ref":"Bumblebee.Audio.html#speech_to_text/5","title":"Bumblebee.Audio.speech_to_text/5","type":"function"},{"doc":"A term representing audio. Can be either of: a 1-dimensional Nx.Tensor with audio samples {:file, path} with path to an audio file (note that this requires ffmpeg installed)","ref":"Bumblebee.Audio.html#t:speech_to_text_input/0","title":"Bumblebee.Audio.speech_to_text_input/0","type":"type"},{"doc":"","ref":"Bumblebee.Audio.html#t:speech_to_text_output/0","title":"Bumblebee.Audio.speech_to_text_output/0","type":"type"},{"doc":"","ref":"Bumblebee.Audio.html#t:speech_to_text_result/0","title":"Bumblebee.Audio.speech_to_text_result/0","type":"type"},{"doc":"High-level tasks based on Stable Diffusion.","ref":"Bumblebee.Diffusion.StableDiffusion.html","title":"Bumblebee.Diffusion.StableDiffusion","type":"module"},{"doc":"Build serving for prompt-driven image generation. The serving accepts text_to_image_input/0 and returns text_to_image_output/0 . A list of inputs is also supported. You can specify :safety_checker model to automatically detect when a generated image is offensive or harmful and filter it out. Options :safety_checker - the safety checker model info map. When a safety checker is used, each output entry has an additional :is_safe property and unsafe images are automatically zeroed. Make sure to also set :safety_checker_featurizer :safety_checker_featurizer - the featurizer to use to preprocess the safety checker input images :num_steps - the number of denoising steps. More denoising steps usually lead to higher image quality at the expense of slower inference. Defaults to 50 :num_images_per_prompt - the number of images to generate for each prompt. Defaults to 1 :guidance_scale - the scale used for classifier-free diffusion guidance. Higher guidance scale makes the generated images more closely reflect the text prompt. This parameter corresponds to $\\omega$ in Equation (2) of the Imagen paper . Defaults to 7.5 :seed - a seed for the random number generator. Defaults to 0 :compile - compiles all computations for predefined input shapes during serving initialization. Should be a keyword list with the following keys: :batch_size - the maximum batch size of the input. Inputs are optionally padded to always match this batch size :sequence_length - the maximum input sequence length. Input sequences are always padded/truncated to match that length It is advised to set this option in production and also configure a defn compiler using :defn_options to maximally reduce inference time. :defn_options - the options for JIT compilation. Defaults to [] Examples repository_id = &quot;CompVis/stable-diffusion-v1-4&quot; { :ok , tokenizer } = Bumblebee . load_tokenizer ( { :hf , &quot;openai/clip-vit-large-patch14&quot; } ) { :ok , clip } = Bumblebee . load_model ( { :hf , repository_id , subdir : &quot;text_encoder&quot; } ) { :ok , unet } = Bumblebee . load_model ( { :hf , repository_id , subdir : &quot;unet&quot; } , params_filename : &quot;diffusion_pytorch_model.bin&quot; ) { :ok , vae } = Bumblebee . load_model ( { :hf , repository_id , subdir : &quot;vae&quot; } , architecture : :decoder , params_filename : &quot;diffusion_pytorch_model.bin&quot; ) { :ok , scheduler } = Bumblebee . load_scheduler ( { :hf , repository_id , subdir : &quot;scheduler&quot; } ) { :ok , featurizer } = Bumblebee . load_featurizer ( { :hf , repository_id , subdir : &quot;feature_extractor&quot; } ) { :ok , safety_checker } = Bumblebee . load_model ( { :hf , repository_id , subdir : &quot;safety_checker&quot; } ) serving = Bumblebee.Diffusion.StableDiffusion . text_to_image ( clip , unet , vae , tokenizer , scheduler , num_steps : 20 , num_images_per_prompt : 2 , safety_checker : safety_checker , safety_checker_featurizer : featurizer , compile : [ batch_size : 1 , sequence_length : 60 ] , defn_options : [ compiler : EXLA ] ) prompt = &quot;numbat in forest, detailed, digital art&quot; Nx.Serving . run ( serving , prompt ) #=&gt; %{ #=&gt; results: [ #=&gt; %{ #=&gt; image: #Nx.Tensor&lt; #=&gt; u8[512][512][3] #=&gt; ... #=&gt; &gt;, #=&gt; is_safe: true #=&gt; }, #=&gt; %{ #=&gt; image: #Nx.Tensor&lt; #=&gt; u8[512][512][3] #=&gt; ... #=&gt; &gt;, #=&gt; is_safe: true #=&gt; } #=&gt; ] #=&gt; }","ref":"Bumblebee.Diffusion.StableDiffusion.html#text_to_image/6","title":"Bumblebee.Diffusion.StableDiffusion.text_to_image/6","type":"function"},{"doc":"","ref":"Bumblebee.Diffusion.StableDiffusion.html#t:text_to_image_input/0","title":"Bumblebee.Diffusion.StableDiffusion.text_to_image_input/0","type":"type"},{"doc":"","ref":"Bumblebee.Diffusion.StableDiffusion.html#t:text_to_image_output/0","title":"Bumblebee.Diffusion.StableDiffusion.text_to_image_output/0","type":"type"},{"doc":"","ref":"Bumblebee.Diffusion.StableDiffusion.html#t:text_to_image_result/0","title":"Bumblebee.Diffusion.StableDiffusion.text_to_image_result/0","type":"type"},{"doc":"High-level tasks related to text processing.","ref":"Bumblebee.Text.html","title":"Bumblebee.Text","type":"module"},{"doc":"Builds serving for conversational generation. The serving accepts conversation_input/0 and returns conversation_output/0 . A list of inputs is also supported. Each call to serving returns the conversation history, which can be fed into the next run to maintain the context. Note that either :max_new_tokens or :max_length must be specified. Options :seed - random seed to use when sampling. By default the current timestamp is used :compile - compiles all computations for predefined input shapes during serving initialization. Should be a keyword list with the following keys: :batch_size - the maximum batch size of the input. Inputs are optionally padded to always match this batch size :sequence_length - the maximum input sequence length. Input sequences are always padded/truncated to match that length. Note that in this case, the whole conversation history is the input, so this value should be relatively large to allow long history (though the supported upper limit depends on the model) It is advised to set this option in production and also configure a defn compiler using :defn_options to maximally reduce inference time. :defn_options - the options for JIT compilation. Defaults to [] Examples { :ok , model_info } = Bumblebee . load_model ( { :hf , &quot;facebook/blenderbot-400M-distill&quot; } ) { :ok , tokenizer } = Bumblebee . load_tokenizer ( { :hf , &quot;facebook/blenderbot-400M-distill&quot; } ) { :ok , generation_config } = Bumblebee . load_generation_config ( { :hf , &quot;facebook/blenderbot-400M-distill&quot; } ) serving = Bumblebee.Text . conversation ( model_info , tokenizer , generation_config ) history = nil message = &quot;Hey!&quot; %{ text : text , history : history } = Nx.Serving . run ( serving , %{ text : message , history : history } ) #=&gt; %{history: ..., text: &quot;Hey !&quot;} message = &quot;What&#39;s up?&quot; %{ text : text , history : history } = Nx.Serving . run ( serving , %{ text : message , history : history } ) #=&gt; %{history: ..., text: &quot;Not much .&quot;}","ref":"Bumblebee.Text.html#conversation/4","title":"Bumblebee.Text.conversation/4","type":"function"},{"doc":"Builds serving for the fill-mask task. The serving accepts fill_mask_input/0 and returns fill_mask_output/0 . A list of inputs is also supported. In the fill-mask task, the objective is to predict a masked word in the text. The serving expects the input to have exactly one such word, denoted as [MASK] . Options :top_k - the number of top predictions to include in the output. If the configured value is higher than the number of labels, all labels are returned. Defaults to 5 :compile - compiles all computations for predefined input shapes during serving initialization. Should be a keyword list with the following keys: :batch_size - the maximum batch size of the input. Inputs are optionally padded to always match this batch size :sequence_length - the maximum input sequence length. Input sequences are always padded/truncated to match that length It is advised to set this option in production and also configure a defn compiler using :defn_options to maximally reduce inference time. :defn_options - the options for JIT compilation. Defaults to [] Examples { :ok , bert } = Bumblebee . load_model ( { :hf , &quot;bert-base-uncased&quot; } ) { :ok , tokenizer } = Bumblebee . load_tokenizer ( { :hf , &quot;bert-base-uncased&quot; } ) serving = Bumblebee.Text . fill_mask ( bert , tokenizer ) text = &quot;The capital of [MASK] is Paris.&quot; Nx.Serving . run ( serving , text ) #=&gt; %{ #=&gt; predictions: [ #=&gt; %{score: 0.9279842972755432, token: &quot;france&quot;}, #=&gt; %{score: 0.008412551134824753, token: &quot;brittany&quot;}, #=&gt; %{score: 0.007433671969920397, token: &quot;algeria&quot;}, #=&gt; %{score: 0.004957548808306456, token: &quot;department&quot;}, #=&gt; %{score: 0.004369721747934818, token: &quot;reunion&quot;} #=&gt; ] #=&gt; }","ref":"Bumblebee.Text.html#fill_mask/3","title":"Bumblebee.Text.fill_mask/3","type":"function"},{"doc":"Builds serving for prompt-driven text generation. The serving accepts generation_input/0 and returns generation_output/0 . A list of inputs is also supported. Options :seed - random seed to use when sampling. By default the current timestamp is used :compile - compiles all computations for predefined input shapes during serving initialization. Should be a keyword list with the following keys: :batch_size - the maximum batch size of the input. Inputs are optionally padded to always match this batch size :sequence_length - the maximum input sequence length. Input sequences are always padded/truncated to match that length It is advised to set this option in production and also configure a defn compiler using :defn_options to maximally reduce inference time. :defn_options - the options for JIT compilation. Defaults to [] Examples { :ok , model_info } = Bumblebee . load_model ( { :hf , &quot;gpt2&quot; } ) { :ok , tokenizer } = Bumblebee . load_tokenizer ( { :hf , &quot;gpt2&quot; } ) { :ok , generation_config } = Bumblebee . load_generation_config ( { :hf , &quot;gpt2&quot; } ) serving = Bumblebee.Text . generation ( model_info , tokenizer , generation_config ) Nx.Serving . run ( serving , &quot;Elixir is a functional&quot; ) #=&gt; %{ #=&gt; results: [ #=&gt; %{ #=&gt; text: &quot;Elixir is a functional programming language that is designed to be used in a variety of applications. It&quot; #=&gt; } #=&gt; ] #=&gt; }","ref":"Bumblebee.Text.html#generation/4","title":"Bumblebee.Text.generation/4","type":"function"},{"doc":"Builds serving for the question answering task. The serving accepts question_answering_input/0 and returns question_answering_output/0 . A list of inputs is also supported. The question answering task finds the most probable answer to a question within the given context text. Options :compile - compiles all computations for predefined input shapes during serving initialization. Should be a keyword list with the following keys: :batch_size - the maximum batch size of the input. Inputs are optionally padded to always match this batch size. Note that the batch size refers to the number of prompts to classify, while the model prediction is made for every combination of prompt and label :sequence_length - the maximum input sequence length. Input sequences are always padded/truncated to match that length It is advised to set this option in production and also configure a defn compiler using :defn_options to maximally reduce inference time. :defn_options - the options for JIT compilation. Defaults to [] Examples { :ok , roberta } = Bumblebee . load_model ( { :hf , &quot;deepset/roberta-base-squad2&quot; } ) { :ok , tokenizer } = Bumblebee . load_tokenizer ( { :hf , &quot;roberta-base&quot; } ) serving = Bumblebee.Text . question_answering ( roberta , tokenizer ) input = %{ question : &quot;What&#39;s my name?&quot; , context : &quot;My name is Sarah and I live in London.&quot; } Nx.Serving . run ( serving , input ) #=&gt; %{results: [%{end: 16, score: 0.81039959192276, start: 11, text: &quot;Sarah&quot;}]}","ref":"Bumblebee.Text.html#question_answering/3","title":"Bumblebee.Text.question_answering/3","type":"function"},{"doc":"Builds serving for text classification. The serving accepts text_classification_input/0 and returns text_classification_output/0 . A list of inputs is also supported. Options :top_k - the number of top predictions to include in the output. If the configured value is higher than the number of labels, all labels are returned. Defaults to 5 :compile - compiles all computations for predefined input shapes during serving initialization. Should be a keyword list with the following keys: :batch_size - the maximum batch size of the input. Inputs are optionally padded to always match this batch size :sequence_length - the maximum input sequence length. Input sequences are always padded/truncated to match that length It is advised to set this option in production and also configure a defn compiler using :defn_options to maximally reduce inference time. :scores_function - the function to use for converting logits to scores. Should be one of :softmax , :sigmoid , or :none . Defaults to :softmax :defn_options - the options for JIT compilation. Defaults to [] Examples { :ok , bertweet } = Bumblebee . load_model ( { :hf , &quot;finiteautomata/bertweet-base-sentiment-analysis&quot; } ) { :ok , tokenizer } = Bumblebee . load_tokenizer ( { :hf , &quot;vinai/bertweet-base&quot; } ) serving = Bumblebee.Text . text_classification ( bertweet , tokenizer ) text = &quot;Cats are cute.&quot; Nx.Serving . run ( serving , text ) #=&gt; %{ #=&gt; predictions: [ #=&gt; %{label: &quot;POS&quot;, score: 0.9876555800437927}, #=&gt; %{label: &quot;NEU&quot;, score: 0.010068908333778381}, #=&gt; %{label: &quot;NEG&quot;, score: 0.002275536535307765} #=&gt; ] #=&gt; }","ref":"Bumblebee.Text.html#text_classification/3","title":"Bumblebee.Text.text_classification/3","type":"function"},{"doc":"Builds serving for text embeddings. The serving accepts text_embedding_input/0 and returns text_embedding_output/0 . A list of inputs is also supported. Options :output_attribute - the attribute of the model output map to retrieve. When the output is a single tensor (rather than a map), this option is ignored. Defaults to :pooled_state :output_pool - pooling to apply on top of the model output, in case it is not already a pooled embedding. Supported values: :mean . By default no pooling is applied :embedding_processor - a post-processing step to apply to the embedding. Supported values: :l2_norm . By default the output is returned as is :compile - compiles all computations for predefined input shapes during serving initialization. Should be a keyword list with the following keys: :batch_size - the maximum batch size of the input. Inputs are optionally padded to always match this batch size :sequence_length - the maximum input sequence length. Input sequences are always padded/truncated to match that length It is advised to set this option in production and also configure a defn compiler using :defn_options to maximally reduce inference time. :defn_options - the options for JIT compilation. Defaults to [] Examples { :ok , model_info } = Bumblebee . load_model ( { :hf , &quot;intfloat/e5-large&quot; } ) { :ok , tokenizer } = Bumblebee . load_tokenizer ( { :hf , &quot;intfloat/e5-large&quot; } ) serving = Bumblebee.Text.TextEmbedding . text_embedding ( model_info , tokenizer ) text = &quot;query: Cats are cute.&quot; Nx.Serving . run ( serving , text ) #=&gt; %{ #=&gt; embedding: #Nx.Tensor&lt; #=&gt; f32[1024] #=&gt; EXLA.Backend&lt;host:0, 0.124908262.1234305056.185360&gt; #=&gt; [-0.9789889454841614, -0.9814645051956177, -0.5015208125114441, 0.9867952466011047, 0.9917466640472412, -0.5557178258895874, -0.18618212640285492, 0.797040581703186, 0.8922086954116821, 0.7599573135375977, -0.16524426639080048, -0.8740050792694092, 0.9433475732803345, 0.7217797636985779, 0.9437620639801025, 0.4694959223270416, 0.40594056248664856, -0.20143413543701172, 0.7144518494606018, -0.8689796924591064, 0.94001305103302, 0.17163503170013428, -0.9896315932273865, 0.4455447494983673, 0.41139301657676697, 0.01911175064742565, -0.11275406181812286, -0.734498143196106, -0.6410953402519226, -0.628239095211029, -0.2570168673992157, 0.475137323141098, -0.7534396052360535, -0.9492156505584717, -0.17271563410758972, 0.9081271886825562, -0.4851466119289398, -0.9440935254096985, -0.20976334810256958, -0.684502899646759, -0.11581139266490936, 0.17509342730045319, 0.05547652021050453, 0.31042391061782837, 0.955132007598877, -0.35595986247062683, 0.016105204820632935, -0.3154579997062683, 0.9630348682403564, ...] #=&gt; &gt; #=&gt; }","ref":"Bumblebee.Text.html#text_embedding/3","title":"Bumblebee.Text.text_embedding/3","type":"function"},{"doc":"Builds serving for token classification. The serving accepts token_classification_input/0 and returns token_classification_output/0 . A list of inputs is also supported. This function can be used for tasks such as named entity recognition (NER) or part of speech tagging (POS). The recognized entities can optionally be aggregated into groups based on the given strategy. Options :aggregation - an optional strategy for aggregating adjacent tokens. Token classification models output probabilities for each possible token class. The aggregation strategy takes scores for each token (which possibly represents subwords) and groups tokens into phrases which are readily interpretable as entities of a certain class. Supported aggregation strategies: nil (default) - corresponds to no aggregation and returns the most likely label for each input token :same - groups adjacent tokens with the same label. If the labels use beginning-inside-outside (BIO) tagging, the boundaries are respected and the prefix is omitted in the output labels :word_first - uses :same strategy except that word tokens cannot end up with different labels. With this strategy word gets the label of the first token of that word when there is ambiguity. Note that this works only on word based models :word_average - uses :same strategy except that word tokens cannot end up with different labels. With this strategy scores are averaged across word tokens and then the maximum label is taken. Note that this works only on word based models :word_max - uses :same strategy except that word tokens cannot end up with different labels. With this strategy word gets the label of the token with the maximum score. Note that this works only on word based models :ignored_labels - the labels to ignore in the final output. The labels should be specified without BIO prefix. Defaults to [&quot;O&quot;] :compile - compiles all computations for predefined input shapes during serving initialization. Should be a keyword list with the following keys: :batch_size - the maximum batch size of the input. Inputs are optionally padded to always match this batch size :sequence_length - the maximum input sequence length. Input sequences are always padded/truncated to match that length It is advised to set this option in production and also configure a defn compiler using :defn_options to maximally reduce inference time. :scores_function - the function to use for converting logits to scores. Should be one of :softmax , :sigmoid , or :none . Defaults to :softmax :defn_options - the options for JIT compilation. Defaults to [] Examples { :ok , bert } = Bumblebee . load_model ( { :hf , &quot;dslim/bert-base-NER&quot; } ) { :ok , tokenizer } = Bumblebee . load_tokenizer ( { :hf , &quot;bert-base-cased&quot; } ) serving = Bumblebee.Text . token_classification ( bert , tokenizer , aggregation : :same ) text = &quot;Rachel Green works at Ralph Lauren in New York City in the sitcom Friends&quot; Nx.Serving . run ( serving , text ) #=&gt; %{ #=&gt; entities: [ #=&gt; %{end: 12, label: &quot;PER&quot;, phrase: &quot;Rachel Green&quot;, score: 0.9997024834156036, start: 0}, #=&gt; %{end: 34, label: &quot;ORG&quot;, phrase: &quot;Ralph Lauren&quot;, score: 0.9968731701374054, start: 22}, #=&gt; %{end: 51, label: &quot;LOC&quot;, phrase: &quot;New York City&quot;, score: 0.9995547334353129, start: 38}, #=&gt; %{end: 73, label: &quot;MISC&quot;, phrase: &quot;Friends&quot;, score: 0.6997143030166626, start: 66} #=&gt; ] #=&gt;}","ref":"Bumblebee.Text.html#token_classification/3","title":"Bumblebee.Text.token_classification/3","type":"function"},{"doc":"Builds serving for the zero-shot classification task. The serving accepts zero_shot_classification_input/0 and returns zero_shot_classification_output/0 . A list of inputs is also supported. The zero-shot task predicts zero-shot labels for a given sequence by proposing each label as a premise-hypothesis pairing. Options :top_k - the number of top predictions to include in the output. If the configured value is higher than the number of labels, all labels are returned. Defaults to 5 :hypothesis_template - an arity-1 function which accepts a label and returns a hypothesis. The default hypothesis format is: &quot;This example is \#{label}&quot;. :compile - compiles all computations for predefined input shapes during serving initialization. Should be a keyword list with the following keys: :batch_size - the maximum batch size of the input. Inputs are optionally padded to always match this batch size. Note that the batch size refers to the number of prompts to classify, while the model prediction is made for every combination of prompt and label :sequence_length - the maximum input sequence length. Input sequences are always padded/truncated to match that length It is advised to set this option in production and also configure a defn compiler using :defn_options to maximally reduce inference time. :defn_options - the options for JIT compilation. Defaults to [] Examples { :ok , model } = Bumblebee . load_model ( { :hf , &quot;facebook/bart-large-mnli&quot; } ) { :ok , tokenizer } = Bumblebee . load_tokenizer ( { :hf , &quot;facebook/bart-large-mnli&quot; } ) labels = [ &quot;cooking&quot; , &quot;traveling&quot; , &quot;dancing&quot; ] zero_shot_serving = Bumblebee.Text . zero_shot_classification ( model , tokenizer , labels ) output = Nx.Serving . run ( zero_shot_serving , &quot;One day I will see the world&quot; ) #=&gt; %{ #=&gt; predictions: [ #=&gt; %{label: &quot;cooking&quot;, score: 0.0070497458800673485}, #=&gt; %{label: &quot;traveling&quot;, score: 0.985000491142273}, #=&gt; %{label: &quot;dancing&quot;, score: 0.007949736900627613} #=&gt; ] #=&gt; }","ref":"Bumblebee.Text.html#zero_shot_classification/4","title":"Bumblebee.Text.zero_shot_classification/4","type":"function"},{"doc":"","ref":"Bumblebee.Text.html#t:conversation_history/0","title":"Bumblebee.Text.conversation_history/0","type":"type"},{"doc":"","ref":"Bumblebee.Text.html#t:conversation_input/0","title":"Bumblebee.Text.conversation_input/0","type":"type"},{"doc":"","ref":"Bumblebee.Text.html#t:conversation_output/0","title":"Bumblebee.Text.conversation_output/0","type":"type"},{"doc":"","ref":"Bumblebee.Text.html#t:fill_mask_input/0","title":"Bumblebee.Text.fill_mask_input/0","type":"type"},{"doc":"","ref":"Bumblebee.Text.html#t:fill_mask_output/0","title":"Bumblebee.Text.fill_mask_output/0","type":"type"},{"doc":"","ref":"Bumblebee.Text.html#t:fill_mask_prediction/0","title":"Bumblebee.Text.fill_mask_prediction/0","type":"type"},{"doc":"","ref":"Bumblebee.Text.html#t:generation_input/0","title":"Bumblebee.Text.generation_input/0","type":"type"},{"doc":"","ref":"Bumblebee.Text.html#t:generation_output/0","title":"Bumblebee.Text.generation_output/0","type":"type"},{"doc":"","ref":"Bumblebee.Text.html#t:generation_result/0","title":"Bumblebee.Text.generation_result/0","type":"type"},{"doc":"","ref":"Bumblebee.Text.html#t:question_answering_input/0","title":"Bumblebee.Text.question_answering_input/0","type":"type"},{"doc":"","ref":"Bumblebee.Text.html#t:question_answering_output/0","title":"Bumblebee.Text.question_answering_output/0","type":"type"},{"doc":"","ref":"Bumblebee.Text.html#t:question_answering_result/0","title":"Bumblebee.Text.question_answering_result/0","type":"type"},{"doc":"","ref":"Bumblebee.Text.html#t:text_classification_input/0","title":"Bumblebee.Text.text_classification_input/0","type":"type"},{"doc":"","ref":"Bumblebee.Text.html#t:text_classification_output/0","title":"Bumblebee.Text.text_classification_output/0","type":"type"},{"doc":"","ref":"Bumblebee.Text.html#t:text_classification_prediction/0","title":"Bumblebee.Text.text_classification_prediction/0","type":"type"},{"doc":"","ref":"Bumblebee.Text.html#t:text_embedding_input/0","title":"Bumblebee.Text.text_embedding_input/0","type":"type"},{"doc":"","ref":"Bumblebee.Text.html#t:text_embedding_output/0","title":"Bumblebee.Text.text_embedding_output/0","type":"type"},{"doc":"A single entity label. Note that start and end indices are expressed in terms of UTF-8 bytes.","ref":"Bumblebee.Text.html#t:token_classification_entity/0","title":"Bumblebee.Text.token_classification_entity/0","type":"type"},{"doc":"","ref":"Bumblebee.Text.html#t:token_classification_input/0","title":"Bumblebee.Text.token_classification_input/0","type":"type"},{"doc":"","ref":"Bumblebee.Text.html#t:token_classification_output/0","title":"Bumblebee.Text.token_classification_output/0","type":"type"},{"doc":"","ref":"Bumblebee.Text.html#t:zero_shot_classification_input/0","title":"Bumblebee.Text.zero_shot_classification_input/0","type":"type"},{"doc":"","ref":"Bumblebee.Text.html#t:zero_shot_classification_output/0","title":"Bumblebee.Text.zero_shot_classification_output/0","type":"type"},{"doc":"","ref":"Bumblebee.Text.html#t:zero_shot_classification_prediction/0","title":"Bumblebee.Text.zero_shot_classification_prediction/0","type":"type"},{"doc":"High-level tasks related to vision.","ref":"Bumblebee.Vision.html","title":"Bumblebee.Vision","type":"module"},{"doc":"Builds serving for image classification. The serving accepts image_classification_input/0 and returns image_classification_output/0 . A list of inputs is also supported. Options :top_k - the number of top predictions to include in the output. If the configured value is higher than the number of labels, all labels are returned. Defaults to 5 :compile - compiles all computations for predefined input shapes during serving initialization. Should be a keyword list with the following keys: :batch_size - the maximum batch size of the input. Inputs are optionally padded to always match this batch size It is advised to set this option in production and also configure a defn compiler using :defn_options to maximally reduce inference time. :scores_function - the function to use for converting logits to scores. Should be one of :softmax , :sigmoid , or :none . Defaults to :softmax :defn_options - the options for JIT compilation. Defaults to [] Examples { :ok , resnet } = Bumblebee . load_model ( { :hf , &quot;microsoft/resnet-50&quot; } ) { :ok , featurizer } = Bumblebee . load_featurizer ( { :hf , &quot;microsoft/resnet-50&quot; } ) serving = Bumblebee.Vision . image_classification ( resnet , featurizer ) image = StbImage . read_file! ( path ) Nx.Serving . run ( serving , image ) #=&gt; %{ #=&gt; predictions: [ #=&gt; %{label: &quot;Egyptian cat&quot;, score: 0.979233980178833}, #=&gt; %{label: &quot;tabby, tabby cat&quot;, score: 0.00679466687142849}, #=&gt; %{label: &quot;tiger cat&quot;, score: 0.005290505941957235}, #=&gt; %{label: &quot;lynx, catamount&quot;, score: 0.004550771787762642}, #=&gt; %{label: &quot;Siamese cat, Siamese&quot;, score: 1.1611092486418784e-4} #=&gt; ] #=&gt; }","ref":"Bumblebee.Vision.html#image_classification/3","title":"Bumblebee.Vision.image_classification/3","type":"function"},{"doc":"Builds serving for image-to-text generation. The serving accepts image_to_text_input/0 and returns image_to_text_output/0 . A list of inputs is also supported. Options :seed - random seed to use when sampling. By default the current timestamp is used :compile - compiles all computations for predefined input shapes during serving initialization. Should be a keyword list with the following keys: :batch_size - the maximum batch size of the input. Inputs are optionally padded to always match this batch size It is advised to set this option in production and also configure a defn compiler using :defn_options to maximally reduce inference time. :defn_options - the options for JIT compilation. Defaults to [] Examples { :ok , blip } = Bumblebee . load_model ( { :hf , &quot;Salesforce/blip-image-captioning-base&quot; } ) { :ok , featurizer } = Bumblebee . load_featurizer ( { :hf , &quot;Salesforce/blip-image-captioning-base&quot; } ) { :ok , tokenizer } = Bumblebee . load_tokenizer ( { :hf , &quot;Salesforce/blip-image-captioning-base&quot; } ) { :ok , generation_config } = Bumblebee . load_generation_config ( { :hf , &quot;Salesforce/blip-image-captioning-base&quot; } ) serving = Bumblebee.Vision . image_to_text ( blip , featurizer , tokenizer , generation_config , defn_options : [ compiler : EXLA ] ) image = StbImage . read_file! ( path ) Nx.Serving . run ( serving , image ) #=&gt; %{results: [%{text: &quot;a cat sitting on a chair&quot;}]}","ref":"Bumblebee.Vision.html#image_to_text/5","title":"Bumblebee.Vision.image_to_text/5","type":"function"},{"doc":"A term representing an image. Either Nx.Tensor or a struct implementing Nx.Container and resolving to a tensor, with the following properties: HWC order RGB color channels alpha channel may be present, but it's usually stripped out integer type ( :s or :u )","ref":"Bumblebee.Vision.html#t:image/0","title":"Bumblebee.Vision.image/0","type":"type"},{"doc":"","ref":"Bumblebee.Vision.html#t:image_classification_input/0","title":"Bumblebee.Vision.image_classification_input/0","type":"type"},{"doc":"","ref":"Bumblebee.Vision.html#t:image_classification_output/0","title":"Bumblebee.Vision.image_classification_output/0","type":"type"},{"doc":"","ref":"Bumblebee.Vision.html#t:image_classification_prediction/0","title":"Bumblebee.Vision.image_classification_prediction/0","type":"type"},{"doc":"","ref":"Bumblebee.Vision.html#t:image_to_text_input/0","title":"Bumblebee.Vision.image_to_text_input/0","type":"type"},{"doc":"","ref":"Bumblebee.Vision.html#t:image_to_text_output/0","title":"Bumblebee.Vision.image_to_text_output/0","type":"type"},{"doc":"","ref":"Bumblebee.Vision.html#t:image_to_text_result/0","title":"Bumblebee.Vision.image_to_text_result/0","type":"type"},{"doc":"Whisper model family. Architectures :base - plain Whisper without any head on top :for_conditional_generation - Whisper with a language modeling head. The head returns logits for each token in the original sequence Inputs &quot;input_features&quot; - {batch_size, input_length, feature_size} Indices of input sequence tokens in the vocabulary. &quot;attention_head_mask&quot; - {num_blocks, num_attention_heads} Mask to nullify selected heads of the self-attention blocks in the encoder. &quot;input_embeddings&quot; - {batch_size, sequence_length, hidden_size} Embedded representation of &quot;input_features&quot; , which can be specified for more control over how &quot;input_features&quot; are embedded than the model's internal embedding lookup. If &quot;input_embeddings&quot; are present, then &quot;input_features&quot; will be ignored. &quot;decoder_input_ids&quot; - {batch_size, target_sequence_length} Indices of decoder input sequence tokens in the vocabulary. &quot;decoder_attention_mask&quot; - {batch_size, target_sequence_length} Mask indicating which decoder tokens to attend to. This is used to ignore padding tokens, which are added when processing a batch of sequences with different length. &quot;decoder_attention_head_mask&quot; - {decoder_num_blocks, decoder_num_attention_heads} Mask to nullify selected heads of the self-attention blocks in the decoder. &quot;decoder_input_embeddings&quot; - {batch_size, sequence_length, hidden_size} Embedded representation of &quot;decoder_input_ids&quot; , which can be specified for more control over how &quot;decoder_input_ids&quot; are embedded than the model's internal embedding lookup. If &quot;decoder_input_embeddings&quot; are present, then &quot;decoder_input_ids&quot; will be ignored. &quot;encoder_hidden_state&quot; - {batch_size, sequence_length, hidden_size} Last hidden state output from the encoder. This hidden state is used in cross-attention blocks in the decoder. If specified, the model will skip the encoding process and use this value directly for cross-attentions in the decoder. &quot;cross_attention_head_mask&quot; - {decoder_num_blocks, decoder_num_attention_heads} Mask to nullify selected heads of the cross-attention blocks in the decoder with shape. &quot;cache&quot; A container with cached layer results used to speed up sequential decoding (autoregression). With cache, certain hidden states are taken from the cache, rather than recomputed on every decoding pass. The cache should be treated as opaque and initialized with Bumblebee.Text.Generation.init_cache/4 . Configuration :vocab_size - the vocabulary size of the model. This corresponds to the number of distinct tokens that can be represented by the decoder . Defaults to 51865 :feature_size - the dimensionality of the input features. This corresponds to the number of Mel bins in the preprocessed input . Defaults to 80 :encoder_max_positions - the vocabulary size of the encoder position embedding. This corresponds to the maximum sequence length of log-mel filter-bank features that the model can process . Defaults to 1500 :decoder_max_positions - the vocabulary size of the decoder position embedding. This corresponds to the maximum sequence length that this model can generate. Typically this is set to a large value just in case, such as 512, 1024 or 2048 . Defaults to 448 :hidden_size - the dimensionality of hidden layers. Defaults to 1024 :encoder_num_blocks - the number of Transformer blocks in the encoder. Defaults to 12 :decoder_num_blocks - the number of Transformer blocks in the decoder. Defaults to 12 :encoder_num_attention_heads - the number of attention heads for each attention layer in the encoder. Defaults to 16 :decoder_num_attention_heads - the number of attention heads for each attention layer in the decoder. Defaults to 16 :activation - the activation function. Defaults to :gelu :dropout_rate - the dropout rate for encoder and decoder. Defaults to 0.1 :attention_dropout_rate - the dropout rate for attention weights. Defaults to 0.0 :activation_dropout_rate - the dropout rate for activations inside fully connected layers. Defaults to 0.0 :initializer_scale - the standard deviation of the normal initializer used for initializing kernel parameters. Defaults to 0.02 :output_hidden_states - whether the model should return all hidden states. Defaults to false :output_attentions - whether the model should return all attentions. Defaults to false","ref":"Bumblebee.Audio.Whisper.html","title":"Bumblebee.Audio.Whisper","type":"module"},{"doc":"A CLIP-based model for detecting unsafe image content. This model is designed primarily to check images generated using Stable Diffusion. Architectures :base - the base safety detection model Inputs &quot;pixel_values&quot; - {batch_size, image_size, image_size, num_channels} Featurized image pixel values. Configuration :clip_spec - the specification of the CLIP model. See Bumblebee.Multimodal.Clip for details References CompVis/stable-diffusion-v1-4","ref":"Bumblebee.Diffusion.StableDiffusion.SafetyChecker.html","title":"Bumblebee.Diffusion.StableDiffusion.SafetyChecker","type":"module"},{"doc":"U-Net model with two spatial dimensions and conditional state. Architectures :base - the U-Net model Inputs &quot;sample&quot; - {batch_size, sample_size, sample_size, in_channels} Sample input with two spatial dimensions. &quot;timestep&quot; - {} The timestep used to parameterize model behaviour in a multi-step process, such as diffusion. &quot;encoder_hidden_state&quot; - {batch_size, sequence_length, hidden_size} The conditional state (context) to use with cross-attention. Configuration :sample_size - the size of the input spatial dimensions. Defaults to 32 :in_channels - the number of channels in the input. Defaults to 4 :out_channels - the number of channels in the output. Defaults to 4 :center_input_sample - whether to center the input sample. Defaults to false :embedding_flip_sin_to_cos - whether to flip the sin to cos in the sinusoidal timestep embedding. Defaults to true :embedding_frequency_correction_term - controls the frequency formula in the timestep sinusoidal embedding. The frequency is computed as $\\omega_i = \\frac{1}{10000^{\\frac{i}{n - s}}}$, for $i \\in \\{0, ..., n-1\\}$, where $n$ is half of the embedding size and $s$ is the shift. Historically, certain implementations of sinusoidal embedding used $s=0$, while others used $s=1$ . Defaults to 0 :hidden_sizes - the dimensionality of hidden layers in each upsample/downsample block. Defaults to [320, 640, 1280, 1280] :depth - the number of residual blocks in each upsample/downsample block. Defaults to 2 :down_block_types - a list of downsample block types. The supported blocks are: :down_block , :cross_attention_down_block . Defaults to [:cross_attention_down_block, :cross_attention_down_block, :cross_attention_down_block, :down_block] :up_block_types - a list of upsample block types. The supported blocks are: :up_block , :cross_attention_up_block . Defaults to [:up_block, :cross_attention_up_block, :cross_attention_up_block, :cross_attention_up_block] :downsample_padding - the padding to use in the downsample convolution. Defaults to [{1, 1}, {1, 1}] :mid_block_scale_factor - the scale factor to use for the mid block. Defaults to 1 :num_attention_heads - the number of attention heads for each attention layer. Optionally can be a list with one number per block. Defaults to 8 :cross_attention_size - the dimensionality of the cross attention features. Defaults to 1280 :use_linear_projection - whether the input/output projection of the transformer block should be linear or convolutional. Defaults to false :activation - the activation function. Defaults to :silu :group_norm_num_groups - the number of groups used by the group normalization layers. Defaults to 32 :group_norm_epsilon - the epsilon used by the group normalization layers. Defaults to 1.0e-5","ref":"Bumblebee.Diffusion.UNet2DConditional.html","title":"Bumblebee.Diffusion.UNet2DConditional","type":"module"},{"doc":"Variational autoencoder (VAE) with Kullback–Leibler divergence (KL) loss. Architectures :base - the entire VAE model :encoder - just the encoder part of the base model :decoder - just the decoder part of the base model Inputs &quot;sample&quot; - {batch_size, sample_size, sample_size, in_channels} Sample input with two spatial dimensions. Note that in case of the :decoder model, the input usually has lower dimensionality. &quot;sample_posterior&quot; - {} When true , the decoder input is sampled from the encoder output distribution. Otherwise the distribution mode value is used instead. This input is only relevant for the :base model. Defaults to false . Configuration :sample_size - the size of the input spatial dimensions. Defaults to 32 :in_channels - the number of channels in the input. Defaults to 3 :out_channels - the number of channels in the output. Defaults to 3 :latent_channels - the number of channels in the latent space. Defaults to 4 :hidden_sizes - the dimensionality of hidden layers in each upsample/downsample block. Defaults to ~c&quot;@&quot; :depth - the number of residual blocks in each upsample/downsample block. Defaults to 1 :down_block_types - a list of downsample block types. Currently the only supported type is :down_block . Defaults to [:down_block] :up_block_types - a list of upsample block types. Currently the only supported type is :up_block . Defaults to [:up_block] :activation - the activation function. Defaults to :silu References Auto-Encoding Variational Bayes","ref":"Bumblebee.Diffusion.VaeKl.html","title":"Bumblebee.Diffusion.VaeKl","type":"module"},{"doc":"The BLIP model for text-image similarity. Architectures :for_conditional_generation - BLIP model with a language modeling head Inputs &quot;pixel_values&quot; - {batch_size, image_size, image_size, num_channels} Featurized image pixel values. &quot;decoder_input_ids&quot; - {batch_size, target_sequence_length} Indices of decoder input sequence tokens in the vocabulary. If not present and &quot;input_ids&quot; is, it will be generated by shifting each token in &quot;input_ids&quot; to the right once. &quot;decoder_attention_mask&quot; - {batch_size, target_sequence_length} Mask indicating which decoder tokens to attend to. This is used to ignore padding tokens, which are added when processing a batch of sequences with different length. &quot;decoder_position_ids&quot; - {batch_size, target_sequence_length} Indices of positions of each decoder input sequence tokens in the position embeddings. &quot;cache&quot; A container with cached layer results used to speed up sequential decoding (autoregression). With cache, certain hidden states are taken from the cache, rather than recomputed on every decoding pass. The cache should be treated as opaque and initialized with Bumblebee.Text.Generation.init_cache/4 . Configuration :text_spec - the specification of the text model. See Bumblebee.Text.BlipText for details :vision_spec - the specification of the vision model. See Bumblebee.Vision.BlipVision for details :projection_size - the dimensionality of text and vision projection layers. Defaults to 512 :logit_scale_initial_value - the initial value for the scaling layer used to scale similarity logits. Defaults to 2.6592 :output_hidden_states - whether the model should return all hidden states. Defaults to false :output_attentions - whether the model should return all attentions. Defaults to false References BLIP: Bootstrapping Language-Image Pre-training for Unified Vision-Language Understanding and Generation","ref":"Bumblebee.Multimodal.Blip.html","title":"Bumblebee.Multimodal.Blip","type":"module"},{"doc":"The CLIP model for text-image similarity. Architectures :base - the base CLIP model Inputs &quot;input_ids&quot; - {batch_size, sequence_length} Indices of input sequence tokens in the vocabulary. &quot;attention_mask&quot; - {batch_size, sequence_length} Mask indicating which tokens to attend to. This is used to ignore padding tokens, which are added when processing a batch of sequences with different length. &quot;position_ids&quot; - {batch_size, sequence_length} Indices of positions of each input sequence tokens in the position embeddings. &quot;pixel_values&quot; - {batch_size, image_size, image_size, num_channels} Featurized image pixel values. Configuration :text_spec - the specification of the text model. See Bumblebee.Text.ClipText for details :vision_spec - the specification of the vision model. See Bumblebee.Vision.ClipVision for details :projection_size - the dimensionality of text and vision projection layers. Defaults to 512 :logit_scale_initial_value - the initial value for the scaling layer used to scale similarity logits. Defaults to 2.6592 :output_hidden_states - whether the model should return all hidden states. Defaults to false :output_attentions - whether the model should return all attentions. Defaults to false References CLIP: Connecting Text and Images Learning Transferable Visual Models From Natural Language Supervision","ref":"Bumblebee.Multimodal.Clip.html","title":"Bumblebee.Multimodal.Clip","type":"module"},{"doc":"LayoutLM Model family. Architectures :base - plain LayoutLM without any head on top :for_masked_language_modeling - LayoutLM with a language modeling head. The head returns logits for each token in the original sequence :for_sequence_classification - LayoutLM with a sequence classification head. The head returns logits corresponding to possible classes :for_token_classification - LayoutLM with a token classification head. The head returns logits for each token in the original sequence :for_question_answering - LayoutLM with a span classification head. The head returns logits for the span start and end positions Inputs &quot;input_ids&quot; - {batch_size, sequence_length} Indices of input sequence tokens in the vocabulary. &quot;attention_mask&quot; - {batch_size, sequence_length} Mask indicating which tokens to attend to. This is used to ignore padding tokens, which are added when processing a batch of sequences with different length. &quot;token_type_ids&quot; - {batch_size, sequence_length} Mask distinguishing groups in the input sequence. This is used in when the input sequence is a semantically a pair of sequences. &quot;position_ids&quot; - {batch_size, sequence_length} Indices of positions of each input sequence tokens in the position embeddings. &quot;attention_head_mask&quot; - {num_blocks, num_attention_heads} Mask to nullify selected heads of the self-attention blocks in the encoder. &quot;bounding_box&quot; - {batch_size, sequence_length, 4} Bounding boxes of each input sequence token. Each bounding box is {x0, y0, x1, y1} where {x0, y0} is the upper left corner and {x1, y1} is the lower right corner. Configuration :vocab_size - the vocabulary size of the token embedding. This corresponds to the number of distinct tokens that can be represented in model input and output . Defaults to 30522 :max_positions - the vocabulary size of the position embedding. This corresponds to the maximum sequence length that this model can process. Typically this is set to a large value just in case, such as 512, 1024 or 2048 . Defaults to 1024 :max_spatial_positions - the maximum value of the spatial position embedding. Typically this is set to a large value just in case, such as 512, 1024, or 2048 . Defaults to 1024 :max_token_types - the vocabulary size of the token type embedding (also referred to as segment embedding). This corresponds to how many different token groups can be distinguished in the input . Defaults to 2 :hidden_size - the dimensionality of hidden layers. Defaults to 768 :num_blocks - the number of Transformer blocks in the encoder. Defaults to 12 :num_attention_heads - the number of attention heads for each attention layer in the decoder. Defaults to 12 :intermediate_size - the dimensionality of the intermediate layer in the transformer feed-forward network (FFN) in the decoder. If not specified, defaults to 4 times :hidden_size . Defaults to 3072 :activation - the activation function. Defaults to :gelu :dropout_rate - the dropout rate for embedding and encoder. Defaults to 0.1 :attention_dropout_rate - the dropout rate for attention weights. Defaults to 0.1 :classifier_dropout_rate - the dropout rate for the classification head. If not specified, the value of :dropout_rate is used instead :initializer_scale - the standard deviation of the normal initializer used for initializing kernel parameters. Defaults to 0.02 :layer_norm_epsilon - the epsilon used by the layer normalization layers. Defaults to 1.0e-12 :output_hidden_states - whether the model should return all hidden states. Defaults to false :output_attentions - whether the model should return all attentions. Defaults to false :num_labels - the number of labels to use in the last layer for the classification task. Defaults to 2 :id_to_label - a map from class index to label. Defaults to %{} References LayoutLM: LayoutLM: Pre-training of Text and Layout for Document Image Understanding","ref":"Bumblebee.Multimodal.LayoutLm.html","title":"Bumblebee.Multimodal.LayoutLm","type":"module"},{"doc":"ALBERT model family. Architectures :base - plain ALBERT without any head on top :for_masked_language_modeling - ALBERT with a language modeling head. The head returns logits for each token in the original sequence :for_sequence_classification - ALBERT with a sequence classification head. The head returns logits corresponding to possible classes :for_token_classification - ALBERT with a token classification head. The head returns logits for each token in the original sequence :for_question_answering - ALBERT with a span classification head. The head returns logits for the span start and end positions :for_multiple_choice - ALBERT with a multiple choice prediction head. Each input in the batch consists of several sequences to choose from and the model returns logits corresponding to those choices :for_pre_training - ALBERT with both MLM and NSP heads as done during the pre-training Inputs &quot;input_ids&quot; - {batch_size, sequence_length} Indices of input sequence tokens in the vocabulary. &quot;attention_mask&quot; - {batch_size, sequence_length} Mask indicating which tokens to attend to. This is used to ignore padding tokens, which are added when processing a batch of sequences with different length. &quot;token_type_ids&quot; - {batch_size, sequence_length} Mask distinguishing groups in the input sequence. This is used in when the input sequence is a semantically a pair of sequences. &quot;position_ids&quot; - {batch_size, sequence_length} Indices of positions of each input sequence tokens in the position embeddings. Exceptions The :for_multiple_choice model accepts groups of sequences, so the expected sequence shape is {batch_size, num_choices, sequence_length} . Configuration :vocab_size - the vocabulary size of the token embedding. This corresponds to the number of distinct tokens that can be represented in model input and output . Defaults to 30000 :max_positions - the vocabulary size of the position embedding. This corresponds to the maximum sequence length that this model can process. Typically this is set to a large value just in case, such as 512, 1024 or 2048 . Defaults to 512 :max_token_types - the vocabulary size of the token type embedding (also referred to as segment embedding). This corresponds to how many different token groups can be distinguished in the input . Defaults to 2 :embedding_size - the dimensionality of all input embeddings. Defaults to 128 :hidden_size - the dimensionality of hidden layers. Defaults to 768 :num_blocks - the number of blocks in the encoder. Note that each block contains :block_depth Transformer blocks . Defaults to 12 :num_groups - the number of groups of encoder blocks. Parameters in the same group are shared. Defaults to 1 :block_depth - the number of Transformer blocks in each encoder block. Defaults to 1 :num_attention_heads - the number of attention heads for each attention layer in the encoder. Defaults to 12 :intermediate_size - the dimensionality of the intermediate layer in the transformer feed-forward network (FFN) in the encoder. Defaults to 16384 :activation - the activation function. Defaults to :gelu :dropout_rate - the dropout rate for embedding and encoder. Defaults to 0.0 :attention_dropout_rate - the dropout rate for attention weights. Defaults to 0.0 :classifier_dropout_rate - the dropout rate for the classification head. If not specified, the value of :dropout_rate is used instead :layer_norm_epsilon - the epsilon used by the layer normalization layers. Defaults to 1.0e-12 :initializer_scale - the standard deviation of the normal initializer used for initializing kernel parameters. Defaults to 0.02 :output_hidden_states - whether the model should return all hidden states. Defaults to false :output_attentions - whether the model should return all attentions. Defaults to false :num_labels - the number of labels to use in the last layer for the classification task. Defaults to 2 :id_to_label - a map from class index to label. Defaults to %{} References ALBERT: A Lite BERT for Self-supervised Learning of Language Representations","ref":"Bumblebee.Text.Albert.html","title":"Bumblebee.Text.Albert","type":"module"},{"doc":"BART model family. Architectures :base - plain BART without any head on top :for_causal_language_modeling - BART with a language modeling head. The head returns logits for each token in the original sequence :for_conditional_generation - BART with a language modeling head. The head returns logits for each token in the original sequence :for_sequence_classification - BART with a sequence classification head. The head returns logits corresponding to possible classes :for_question_answering - BART with a span classification head. The head returns logits for the span start and end positions Inputs &quot;input_ids&quot; - {batch_size, sequence_length} Indices of input sequence tokens in the vocabulary. &quot;attention_mask&quot; - {batch_size, sequence_length} Mask indicating which tokens to attend to. This is used to ignore padding tokens, which are added when processing a batch of sequences with different length. &quot;position_ids&quot; - {batch_size, sequence_length} Indices of positions of each input sequence tokens in the position embeddings. &quot;attention_head_mask&quot; - {encoder_num_blocks, encoder_num_attention_heads} Mask to nullify selected heads of the self-attention blocks in the encoder. &quot;input_embeddings&quot; - {batch_size, sequence_length, hidden_size} Embedded representation of &quot;input_ids&quot; , which can be specified for more control over how &quot;input_ids&quot; are embedded than the model's internal embedding lookup. If &quot;input_embeddings&quot; are present, then &quot;input_ids&quot; will be ignored. &quot;decoder_input_ids&quot; - {batch_size, target_sequence_length} Indices of decoder input sequence tokens in the vocabulary. If not present and &quot;input_ids&quot; is, it will be generated by shifting each token in &quot;input_ids&quot; to the right once. &quot;decoder_attention_mask&quot; - {batch_size, target_sequence_length} Mask indicating which decoder tokens to attend to. This is used to ignore padding tokens, which are added when processing a batch of sequences with different length. &quot;decoder_position_ids&quot; - {batch_size, target_sequence_length} Indices of positions of each decoder input sequence tokens in the position embeddings. &quot;decoder_attention_head_mask&quot; - {decoder_num_blocks, decoder_num_attention_heads} Mask to nullify selected heads of the self-attention blocks in the decoder. &quot;decoder_input_embeddings&quot; - {batch_size, sequence_length, hidden_size} Embedded representation of &quot;decoder_input_ids&quot; , which can be specified for more control over how &quot;decoder_input_ids&quot; are embedded than the model's internal embedding lookup. If &quot;decoder_input_embeddings&quot; are present, then &quot;decoder_input_ids&quot; will be ignored. &quot;encoder_hidden_state&quot; - {batch_size, sequence_length, hidden_size} Last hidden state output from the encoder. This hidden state is used in cross-attention blocks in the decoder. If specified, the model will skip the encoding process and use this value directly for cross-attentions in the decoder. &quot;cross_attention_head_mask&quot; - {decoder_num_blocks, decoder_num_attention_heads} Mask to nullify selected heads of the cross-attention blocks in the decoder with shape. &quot;cache&quot; A container with cached layer results used to speed up sequential decoding (autoregression). With cache, certain hidden states are taken from the cache, rather than recomputed on every decoding pass. The cache should be treated as opaque and initialized with Bumblebee.Text.Generation.init_cache/4 . Exceptions The :for_causal_language_modeling model is just the decoder part and accepts the following inputs instead: &quot;input_ids&quot; , &quot;attention_mask&quot; , &quot;position_ids&quot; , &quot;attention_head_mask&quot; , &quot;input_embeddings&quot; , &quot;encoder_hidden_state&quot; , &quot;encoder_attention_mask&quot; , &quot;cross_attention_head_mask&quot; , &quot;cache&quot; . Configuration :vocab_size - the vocabulary size of the token embedding. This corresponds to the number of distinct tokens that can be represented in model input and output . Defaults to 50265 :max_positions - the vocabulary size of the position embedding. This corresponds to the maximum sequence length that this model can process. Typically this is set to a large value just in case, such as 512, 1024 or 2048 . Defaults to 1024 :hidden_size - the dimensionality of hidden layers. Defaults to 1024 :encoder_num_blocks - the number of Transformer blocks in the encoder. Defaults to 12 :decoder_num_blocks - the number of Transformer blocks in the decoder. Defaults to 12 :encoder_num_attention_heads - the number of attention heads for each attention layer in the encoder. Defaults to 16 :decoder_num_attention_heads - the number of attention heads for each attention layer in the decoder. Defaults to 16 :scale_embedding - whether to scale embeddings by dividing by the square root of :hidden_size . Defaults to false :activation - the activation function. Defaults to :gelu :dropout_rate - the dropout rate for encoder and decoder. Defaults to 0.1 :attention_dropout_rate - the dropout rate for attention weights. Defaults to 0.0 :activation_dropout_rate - the dropout rate for activations inside fully connected layers. Defaults to 0.0 :classifier_dropout_rate - the dropout rate for the classification head. Defaults to 0.0 :initializer_scale - the standard deviation of the normal initializer used for initializing kernel parameters. Defaults to 0.02 :output_hidden_states - whether the model should return all hidden states. Defaults to false :output_attentions - whether the model should return all attentions. Defaults to false :num_labels - the number of labels to use in the last layer for the classification task. Defaults to 2 :id_to_label - a map from class index to label. Defaults to %{}","ref":"Bumblebee.Text.Bart.html","title":"Bumblebee.Text.Bart","type":"module"},{"doc":"BERT model family. Architectures :base - plain BERT without any head on top :for_masked_language_modeling - BERT with a language modeling head. The head returns logits for each token in the original sequence :for_sequence_classification - BERT with a sequence classification head. The head returns logits corresponding to possible classes :for_token_classification - BERT with a token classification head. The head returns logits for each token in the original sequence :for_question_answering - BERT with a span classification head. The head returns logits for the span start and end positions :for_multiple_choice - BERT with a multiple choice prediction head. Each input in the batch consists of several sequences to choose from and the model returns logits corresponding to those choices :for_next_sentence_prediction - BERT with a next sentence prediction head. The head returns logits predicting whether the second sentence is random or in context :for_pre_training - BERT with both MLM and NSP heads as done during the pre-training :for_causal_language_modeling - BERT working as a decoder with a language modeling head. The head returns logits for each token in the original sequence Inputs &quot;input_ids&quot; - {batch_size, sequence_length} Indices of input sequence tokens in the vocabulary. &quot;attention_mask&quot; - {batch_size, sequence_length} Mask indicating which tokens to attend to. This is used to ignore padding tokens, which are added when processing a batch of sequences with different length. &quot;token_type_ids&quot; - {batch_size, sequence_length} Mask distinguishing groups in the input sequence. This is used in when the input sequence is a semantically a pair of sequences. &quot;position_ids&quot; - {batch_size, sequence_length} Indices of positions of each input sequence tokens in the position embeddings. &quot;attention_head_mask&quot; - {num_blocks, num_attention_heads} Mask to nullify selected heads of the self-attention blocks in the encoder. Exceptions The :for_multiple_choice model accepts groups of sequences, so the expected sequence shape is {batch_size, num_choices, sequence_length} . The :for_causal_language_modeling model is a decoder and accepts the following additional inputs: &quot;encoder_hidden_state&quot; , &quot;encoder_attention_mask&quot; , &quot;cross_attention_head_mask&quot; , &quot;cache&quot; . Configuration :vocab_size - the vocabulary size of the token embedding. This corresponds to the number of distinct tokens that can be represented in model input and output . Defaults to 30522 :max_positions - the vocabulary size of the position embedding. This corresponds to the maximum sequence length that this model can process. Typically this is set to a large value just in case, such as 512, 1024 or 2048 . Defaults to 512 :max_token_types - the vocabulary size of the token type embedding (also referred to as segment embedding). This corresponds to how many different token groups can be distinguished in the input . Defaults to 2 :hidden_size - the dimensionality of hidden layers. Defaults to 768 :num_blocks - the number of Transformer blocks in the encoder. Defaults to 12 :num_attention_heads - the number of attention heads for each attention layer in the encoder. Defaults to 12 :intermediate_size - the dimensionality of the intermediate layer in the transformer feed-forward network (FFN) in the encoder. Defaults to 3072 :activation - the activation function. Defaults to :gelu :dropout_rate - the dropout rate for embedding and encoder. Defaults to 0.1 :attention_dropout_rate - the dropout rate for attention weights. Defaults to 0.1 :classifier_dropout_rate - the dropout rate for the classification head. If not specified, the value of :dropout_rate is used instead :layer_norm_epsilon - the epsilon used by the layer normalization layers. Defaults to 1.0e-12 :initializer_scale - the standard deviation of the normal initializer used for initializing kernel parameters. Defaults to 0.02 :output_hidden_states - whether the model should return all hidden states. Defaults to false :output_attentions - whether the model should return all attentions. Defaults to false :num_labels - the number of labels to use in the last layer for the classification task. Defaults to 2 :id_to_label - a map from class index to label. Defaults to %{} :use_cross_attention - whether cross-attention layers should be added to the model.This is only relevant for decoder models. Defaults to false References BERT: Pre-training of Deep Bidirectional Transformers for Language Understanding","ref":"Bumblebee.Text.Bert.html","title":"Bumblebee.Text.Bert","type":"module"},{"doc":"Blenderbot model family. Architectures :base - plain Blenderbot without any head on top :for_conditional_generation - Blenderbot with a language modeling head. The head returns logits for each token in the original sequence Inputs &quot;input_ids&quot; - {batch_size, sequence_length} Indices of input sequence tokens in the vocabulary. &quot;attention_mask&quot; - {batch_size, sequence_length} Mask indicating which tokens to attend to. This is used to ignore padding tokens, which are added when processing a batch of sequences with different length. &quot;position_ids&quot; - {batch_size, sequence_length} Indices of positions of each input sequence tokens in the position embeddings. &quot;attention_head_mask&quot; - {encoder_num_blocks, encoder_num_attention_heads} Mask to nullify selected heads of the self-attention blocks in the encoder. &quot;input_embeddings&quot; - {batch_size, sequence_length, hidden_size} Embedded representation of &quot;input_ids&quot; , which can be specified for more control over how &quot;input_ids&quot; are embedded than the model's internal embedding lookup. If &quot;input_embeddings&quot; are present, then &quot;input_ids&quot; will be ignored. &quot;decoder_input_ids&quot; - {batch_size, target_sequence_length} Indices of decoder input sequence tokens in the vocabulary. If not present and &quot;input_ids&quot; is, it will be generated by shifting each token in &quot;input_ids&quot; to the right once. &quot;decoder_attention_mask&quot; - {batch_size, target_sequence_length} Mask indicating which decoder tokens to attend to. This is used to ignore padding tokens, which are added when processing a batch of sequences with different length. &quot;decoder_position_ids&quot; - {batch_size, target_sequence_length} Indices of positions of each decoder input sequence tokens in the position embeddings. &quot;decoder_attention_head_mask&quot; - {decoder_num_blocks, decoder_num_attention_heads} Mask to nullify selected heads of the self-attention blocks in the decoder. &quot;decoder_input_embeddings&quot; - {batch_size, sequence_length, hidden_size} Embedded representation of &quot;decoder_input_ids&quot; , which can be specified for more control over how &quot;decoder_input_ids&quot; are embedded than the model's internal embedding lookup. If &quot;decoder_input_embeddings&quot; are present, then &quot;decoder_input_ids&quot; will be ignored. &quot;encoder_hidden_state&quot; - {batch_size, sequence_length, hidden_size} Last hidden state output from the encoder. This hidden state is used in cross-attention blocks in the decoder. If specified, the model will skip the encoding process and use this value directly for cross-attentions in the decoder. &quot;cross_attention_head_mask&quot; - {decoder_num_blocks, decoder_num_attention_heads} Mask to nullify selected heads of the cross-attention blocks in the decoder with shape. &quot;cache&quot; A container with cached layer results used to speed up sequential decoding (autoregression). With cache, certain hidden states are taken from the cache, rather than recomputed on every decoding pass. The cache should be treated as opaque and initialized with Bumblebee.Text.Generation.init_cache/4 . Configuration :vocab_size - the vocabulary size of the token embedding. This corresponds to the number of distinct tokens that can be represented in model input and output . Defaults to 8008 :max_positions - the vocabulary size of the position embedding. This corresponds to the maximum sequence length that this model can process. Typically this is set to a large value just in case, such as 512, 1024 or 2048 . Defaults to 128 :hidden_size - the dimensionality of hidden layers. Defaults to 2560 :encoder_num_blocks - the number of Transformer blocks in the encoder. Defaults to 2 :decoder_num_blocks - the number of Transformer blocks in the decoder. Defaults to 24 :encoder_num_attention_heads - the number of attention heads for each attention layer in the encoder. Defaults to 32 :decoder_num_attention_heads - the number of attention heads for each attention layer in the decoder. Defaults to 32 :scale_embedding - whether to scale embeddings by dividing by the square root of :hidden_size . Defaults to false :activation - the activation function. Defaults to :gelu :dropout_rate - the dropout rate for encoder and decoder. Defaults to 0.1 :attention_dropout_rate - the dropout rate for attention weights. Defaults to 0.0 :activation_dropout_rate - the dropout rate for activations inside fully connected layers. Defaults to 0.0 :initializer_scale - the standard deviation of the normal initializer used for initializing kernel parameters. Defaults to 0.02 :output_hidden_states - whether the model should return all hidden states. Defaults to false :output_attentions - whether the model should return all attentions. Defaults to false","ref":"Bumblebee.Text.Blenderbot.html","title":"Bumblebee.Text.Blenderbot","type":"module"},{"doc":"The BLIP model for text encoding. Architectures :base - the base text model Inputs &quot;input_ids&quot; - {batch_size, sequence_length} Indices of input sequence tokens in the vocabulary. &quot;attention_mask&quot; - {batch_size, sequence_length} Mask indicating which tokens to attend to. This is used to ignore padding tokens, which are added when processing a batch of sequences with different length. &quot;position_ids&quot; - {batch_size, sequence_length} Indices of positions of each input sequence tokens in the position embeddings. &quot;attention_head_mask&quot; - {encoder_num_blocks, encoder_num_attention_heads} Mask to nullify selected heads of the self-attention blocks in the encoder. &quot;input_embeddings&quot; - {batch_size, sequence_length, hidden_size} Embedded representation of &quot;input_ids&quot; , which can be specified for more control over how &quot;input_ids&quot; are embedded than the model's internal embedding lookup. If &quot;input_embeddings&quot; are present, then &quot;input_ids&quot; will be ignored. &quot;encoder_hidden_state&quot; - {batch_size, encoder_sequence_length, encoder_hidden_size} Last hidden state output from the encoder. This hidden state is used in cross-attention blocks in the decoder. If specified, the model will skip the encoding process and use this value directly for cross-attentions in the decoder. &quot;encoder_attention_mask&quot; - {batch_size, encoder_sequence_length} Mask indicating which tokens to attend to. This is used to ignore padding tokens, which are added when processing a batch of sequences with different length. &quot;cross_attention_head_mask&quot; - {num_blocks, num_attention_heads} Mask to nullify selected heads of the cross-attention blocks in the decoder with shape. &quot;cache&quot; A container with cached layer results used to speed up sequential decoding (autoregression). With cache, certain hidden states are taken from the cache, rather than recomputed on every decoding pass. The cache should be treated as opaque and initialized with Bumblebee.Text.Generation.init_cache/4 . Configuration :vocab_size - the vocabulary size of the token embedding. This corresponds to the number of distinct tokens that can be represented in model input and output . Defaults to 30524 :max_positions - the vocabulary size of the position embedding. This corresponds to the maximum sequence length that this model can process. Typically this is set to a large value just in case, such as 512, 1024 or 2048 . Defaults to 512 :hidden_size - the dimensionality of hidden layers. Defaults to 768 :encoder_hidden_size - the dimensionality of hidden layers in the vision encoder. Defaults to 768 :num_blocks - the number of Transformer blocks in the encoder. Defaults to 12 :num_attention_heads - the number of attention heads for each attention layer in the encoder. Defaults to 8 :intermediate_size - the dimensionality of the intermediate layer in the transformer feed-forward network (FFN) in the encoder. Defaults to 3072 :activation - the activation function. Defaults to :gelu :dropout_rate - the dropout rate for embedding and encoder. Defaults to 0.0 :attention_dropout_rate - the dropout rate for attention weights. Defaults to 0.0 :layer_norm_epsilon - the epsilon used by the layer normalization layers. Defaults to 1.0e-12 :initializer_scale - the standard deviation of the normal initializer used for initializing kernel parameters. Defaults to 0.02 :output_hidden_states - whether the model should return all hidden states. Defaults to false :output_attentions - whether the model should return all attentions. Defaults to false","ref":"Bumblebee.Text.BlipText.html","title":"Bumblebee.Text.BlipText","type":"module"},{"doc":"The CLIP model for text encoding. Architectures :base - the base text model Inputs &quot;input_ids&quot; - {batch_size, sequence_length} Indices of input sequence tokens in the vocabulary. &quot;attention_mask&quot; - {batch_size, sequence_length} Mask indicating which tokens to attend to. This is used to ignore padding tokens, which are added when processing a batch of sequences with different length. &quot;position_ids&quot; - {batch_size, sequence_length} Indices of positions of each input sequence tokens in the position embeddings. Configuration :vocab_size - the vocabulary size of the token embedding. This corresponds to the number of distinct tokens that can be represented in model input and output . Defaults to 49408 :max_positions - the vocabulary size of the position embedding. This corresponds to the maximum sequence length that this model can process. Typically this is set to a large value just in case, such as 512, 1024 or 2048 . Defaults to 77 :hidden_size - the dimensionality of hidden layers. Defaults to 512 :num_blocks - the number of Transformer blocks in the encoder. Defaults to 12 :num_attention_heads - the number of attention heads for each attention layer in the encoder. Defaults to 8 :intermediate_size - the dimensionality of the intermediate layer in the transformer feed-forward network (FFN) in the encoder. Defaults to 2048 :activation - the activation function. Defaults to :quick_gelu :attention_dropout_rate - the dropout rate for attention weights. Defaults to 0.0 :layer_norm_epsilon - the epsilon used by the layer normalization layers. Defaults to 1.0e-5 :output_hidden_states - whether the model should return all hidden states. Defaults to false :output_attentions - whether the model should return all attentions. Defaults to false :num_labels - the number of labels to use in the last layer for the classification task. Defaults to 2 :id_to_label - a map from class index to label. Defaults to %{}","ref":"Bumblebee.Text.ClipText.html","title":"Bumblebee.Text.ClipText","type":"module"},{"doc":"DistilBERT model family. Architectures :base - plain DistilBERT without any head on top :for_masked_language_modeling - DistilBERT with a language modeling head. The head returns logits for each token in the original sequence :for_sequence_classification - DistilBERT with a sequence classification head. The head returns logits corresponding to possible classes :for_token_classification - DistilBERT with a token classification head. The head returns logits for each token in the original sequence :for_question_answering - DistilBERT with a span classification head. The head returns logits for the span start and end positions :for_multiple_choice - DistilBERT with a multiple choice prediction head. Each input in the batch consists of several sequences to choose from and the model returns logits corresponding to those choices Inputs &quot;input_ids&quot; - {batch_size, sequence_length} Indices of input sequence tokens in the vocabulary. &quot;attention_mask&quot; - {batch_size, sequence_length} Mask indicating which tokens to attend to. This is used to ignore padding tokens, which are added when processing a batch of sequences with different length. Mask distinguishing groups in the input sequence. This is used in when the input sequence is a semantically a pair of sequences. &quot;position_ids&quot; - {batch_size, sequence_length} Indices of positions of each input sequence tokens in the position embeddings. &quot;attention_head_mask&quot; - {num_blocks, num_attention_heads} Mask to nullify selected heads of the self-attention blocks in the encoder. Exceptions The :for_multiple_choice model accepts groups of sequences, so the expected sequence shape is {batch_size, num_choices, sequence_length} . Configuration :vocab_size - the vocabulary size of the token embedding. This corresponds to the number of distinct tokens that can be represented in model input and output . Defaults to 30522 :max_positions - the vocabulary size of the position embedding. This corresponds to the maximum sequence length that this model can process. Typically this is set to a large value just in case, such as 512, 1024 or 2048 . Defaults to 512 :hidden_size - the dimensionality of hidden layers. Defaults to 768 :num_blocks - the number of Transformer blocks in the encoder. Defaults to 6 :num_attention_heads - the number of attention heads for each attention layer in the encoder. Defaults to 12 :intermediate_size - the dimensionality of the intermediate layer in the transformer feed-forward network (FFN) in the encoder. Defaults to 3072 :activation - the activation function. Defaults to :gelu :dropout_rate - the dropout rate for embedding and encoder. Defaults to 0.1 :attention_dropout_rate - the dropout rate for attention weights. Defaults to 0.1 :classifier_dropout_rate - the dropout rate for the classification head. If not specified, the value of :dropout_rate is used instead :layer_norm_epsilon - the epsilon used by the layer normalization layers. Defaults to 1.0e-12 :initializer_scale - the standard deviation of the normal initializer used for initializing kernel parameters. Defaults to 0.02 :output_hidden_states - whether the model should return all hidden states. Defaults to false :output_attentions - whether the model should return all attentions. Defaults to false :num_labels - the number of labels to use in the last layer for the classification task. Defaults to 2 :id_to_label - a map from class index to label. Defaults to %{} :use_cross_attention - whether cross-attention layers should be added to the model.This is only relevant for decoder models. Defaults to false References DistilBERT, a distilled version of BERT: smaller, faster, cheaper and lighter","ref":"Bumblebee.Text.Distilbert.html","title":"Bumblebee.Text.Distilbert","type":"module"},{"doc":"GPT-2 model family. Architectures :base - plain GPT-2 without any head on top :for_causal_language_modeling - GPT-2 with a language modeling head. The head returns logits for each token in the original sequence :for_sequence_classification - GPT-2 with a sequence classification head. The head returns logits corresponding to possible classes :for_token_classification - GPT-2 with a token classification head. The head returns logits for each token in the original sequence Inputs &quot;input_ids&quot; - {batch_size, sequence_length} Indices of input sequence tokens in the vocabulary. &quot;attention_mask&quot; - {batch_size, sequence_length} Mask indicating which tokens to attend to. This is used to ignore padding tokens, which are added when processing a batch of sequences with different length. &quot;position_ids&quot; - {batch_size, sequence_length} Indices of positions of each input sequence tokens in the position embeddings. &quot;attention_head_mask&quot; - {num_blocks, num_attention_heads} Mask to nullify selected heads of the self-attention blocks in the encoder. &quot;input_embeddings&quot; - {batch_size, sequence_length, hidden_size} Embedded representation of &quot;input_ids&quot; , which can be specified for more control over how &quot;input_ids&quot; are embedded than the model's internal embedding lookup. If &quot;input_embeddings&quot; are present, then &quot;input_ids&quot; will be ignored. &quot;encoder_hidden_state&quot; - {batch_size, encoder_sequence_length, hidden_size} Last hidden state output from the encoder. This hidden state is used in cross-attention blocks in the decoder. If specified, the model will skip the encoding process and use this value directly for cross-attentions in the decoder. &quot;encoder_attention_mask&quot; - {batch_size, encoder_sequence_length} Mask indicating which tokens to attend to. This is used to ignore padding tokens, which are added when processing a batch of sequences with different length. &quot;cross_attention_head_mask&quot; - {num_blocks, num_attention_heads} Mask to nullify selected heads of the cross-attention blocks in the decoder with shape. &quot;cache&quot; A container with cached layer results used to speed up sequential decoding (autoregression). With cache, certain hidden states are taken from the cache, rather than recomputed on every decoding pass. The cache should be treated as opaque and initialized with Bumblebee.Text.Generation.init_cache/4 . Configuration :vocab_size - the vocabulary size of the token embedding. This corresponds to the number of distinct tokens that can be represented in model input and output . Defaults to 50257 :max_positions - the vocabulary size of the position embedding. This corresponds to the maximum sequence length that this model can process. Typically this is set to a large value just in case, such as 512, 1024 or 2048 . Defaults to 1024 :hidden_size - the dimensionality of hidden layers. Defaults to 768 :num_blocks - the number of Transformer blocks in the decoder. Defaults to 24 :num_attention_heads - the number of attention heads for each attention layer in the decoder. Defaults to 16 :intermediate_size - the dimensionality of the intermediate layer in the transformer feed-forward network (FFN) in the decoder. If not specified, defaults to 4 times :hidden_size :activation - the activation function. Defaults to :gelu_new :dropout_rate - the dropout rate for embedding and encoder. Defaults to 0.1 :embeddings_dropout_rate - the dropout rate for embeddings. Defaults to 0.1 :attention_dropout_rate - the dropout rate for attention weights. Defaults to 0.1 :classifier_dropout_rate - the dropout rate for the classification head. Defaults to 0.1 :layer_norm_epsilon - the epsilon used by the layer normalization layers. Defaults to 1.0e-5 :initializer_scale - the standard deviation of the normal initializer used for initializing kernel parameters. Defaults to 0.02 :output_hidden_states - whether the model should return all hidden states. Defaults to false :output_attentions - whether the model should return all attentions. Defaults to false :num_labels - the number of labels to use in the last layer for the classification task. Defaults to 2 :id_to_label - a map from class index to label. Defaults to %{} :use_cross_attention - whether cross-attention layers should be added to the model.This is only relevant for decoder models. Defaults to false","ref":"Bumblebee.Text.Gpt2.html","title":"Bumblebee.Text.Gpt2","type":"module"},{"doc":"GPT-NeoX model family. Architectures :base - plain GPT-NeoX without any head on top :for_causal_language_modeling - GPT-NeoX with a language modeling head. The head returns logits for each token in the original sequence :for_sequence_classification - GPT-NeoX with a sequence classification head. The head returns logits corresponding to possible classes :for_token_classification - GPT-NeoX with a token classification head. The head returns logits for each token in the original sequence Inputs &quot;input_ids&quot; - {batch_size, sequence_length} Indices of input sequence tokens in the vocabulary. &quot;attention_mask&quot; - {batch_size, sequence_length} Mask indicating which tokens to attend to. This is used to ignore padding tokens, which are added when processing a batch of sequences with different length. &quot;position_ids&quot; - {batch_size, sequence_length} Indices of positions of each input sequence tokens in the position embeddings. &quot;attention_head_mask&quot; - {encoder_num_blocks, encoder_num_attention_heads} Mask to nullify selected heads of the self-attention blocks in the encoder. &quot;input_embeddings&quot; - {batch_size, sequence_length, hidden_size} Embedded representation of &quot;input_ids&quot; , which can be specified for more control over how &quot;input_ids&quot; are embedded than the model's internal embedding lookup. If &quot;input_embeddings&quot; are present, then &quot;input_ids&quot; will be ignored. &quot;cache&quot; A container with cached layer results used to speed up sequential decoding (autoregression). With cache, certain hidden states are taken from the cache, rather than recomputed on every decoding pass. The cache should be treated as opaque and initialized with Bumblebee.Text.Generation.init_cache/4 . Configuration :vocab_size - the vocabulary size of the token embedding. This corresponds to the number of distinct tokens that can be represented in model input and output . Defaults to 32000 :hidden_size - the dimensionality of hidden layers. Defaults to 4096 :intermediate_size - the dimensionality of intermediate layers. Defaults to 11008 :num_blocks - the number of Transformer blocks in the model. Defaults to 32 :num_attention_heads - the number of attention heads for each attention layer in the model. Defaults to 32 :activation - the activation function. Defaults to :silu :rotary_embedding_percentage - percentage of hidden dimensions to allocate to rotary embeddings. Defaults to 0.25 :rotary_embedding_base - base for computing rotary embedding frequency. Defaults to 10000 :classifier_dropout_rate - the dropout rate for the classification head. Defaults to 0.1 :layer_norm_epsilon - the epsilon used by RMS normalization layers. Defaults to 1.0e-12 :initializer_scale - the standard deviation of the normal initializer used for initializing kernel parameters. Defaults to 0.02 :use_parallel_transformer_block - whether to use the parallel formulation of the Transformer block, where attention and FFN is computed independently. Defaults to true :output_hidden_states - whether the model should return all hidden states. Defaults to false :output_attentions - whether the model should return all attentions. Defaults to false :num_labels - the number of labels to use in the last layer for the classification task. Defaults to 2 :id_to_label - a map from class index to label. Defaults to %{}","ref":"Bumblebee.Text.GptNeoX.html","title":"Bumblebee.Text.GptNeoX","type":"module"},{"doc":"LLaMA model family. Architectures :base - plain LLaMA without any head on top :for_causal_language_modeling - LLaMA with a language modeling head. The head returns logits for each token in the original sequence :for_sequence_classification - LLaMA with a sequence classification head. The head returns logits corresponding to possible classes Inputs &quot;input_ids&quot; - {batch_size, sequence_length} Indices of input sequence tokens in the vocabulary. &quot;attention_mask&quot; - {batch_size, sequence_length} Mask indicating which tokens to attend to. This is used to ignore padding tokens, which are added when processing a batch of sequences with different length. &quot;position_ids&quot; - {batch_size, sequence_length} Indices of positions of each input sequence tokens in the position embeddings. &quot;attention_head_mask&quot; - {encoder_num_blocks, encoder_num_attention_heads} Mask to nullify selected heads of the self-attention blocks in the encoder. &quot;input_embeddings&quot; - {batch_size, sequence_length, hidden_size} Embedded representation of &quot;input_ids&quot; , which can be specified for more control over how &quot;input_ids&quot; are embedded than the model's internal embedding lookup. If &quot;input_embeddings&quot; are present, then &quot;input_ids&quot; will be ignored. &quot;cache&quot; A container with cached layer results used to speed up sequential decoding (autoregression). With cache, certain hidden states are taken from the cache, rather than recomputed on every decoding pass. The cache should be treated as opaque and initialized with Bumblebee.Text.Generation.init_cache/4 . Configuration :vocab_size - the vocabulary size of the token embedding. This corresponds to the number of distinct tokens that can be represented in model input and output . Defaults to 32000 :max_positions - the vocabulary size of the position embedding. This corresponds to the maximum sequence length that this model can process. Typically this is set to a large value just in case, such as 512, 1024 or 2048 . Defaults to 1024 :hidden_size - the dimensionality of hidden layers. Defaults to 4096 :intermediate_size - the dimensionality of intermediate layers. Defaults to 11008 :num_blocks - the number of Transformer blocks in the model. Defaults to 32 :num_attention_heads - the number of attention heads for each attention layer in the model. Defaults to 32 :activation - the activation function. Defaults to :silu :layer_norm_epsilon - the epsilon used by RMS normalization layers. Defaults to 1.0e-12 :initializer_scale - the standard deviation of the normal initializer used for initializing kernel parameters. Defaults to 0.02 :output_hidden_states - whether the model should return all hidden states. Defaults to false :output_attentions - whether the model should return all attentions. Defaults to false :num_labels - the number of labels to use in the last layer for the classification task. Defaults to 2 :id_to_label - a map from class index to label. Defaults to %{}","ref":"Bumblebee.Text.Llama.html","title":"Bumblebee.Text.Llama","type":"module"},{"doc":"mBART model family. Architectures :base - plain mBART without any head on top :for_causal_language_modeling - mBART with a language modeling head. The head returns logits for each token in the original sequence :for_conditional_generation - mBART with a language modeling head. The head returns logits for each token in the original sequence :for_sequence_classification - mBART with a sequence classification head. The head returns logits corresponding to possible classes :for_question_answering - mBART with a span classification head. The head returns logits for the span start and end positions Inputs &quot;input_ids&quot; - {batch_size, sequence_length} Indices of input sequence tokens in the vocabulary. &quot;attention_mask&quot; - {batch_size, sequence_length} Mask indicating which tokens to attend to. This is used to ignore padding tokens, which are added when processing a batch of sequences with different length. &quot;position_ids&quot; - {batch_size, sequence_length} Indices of positions of each input sequence tokens in the position embeddings. &quot;attention_head_mask&quot; - {encoder_num_blocks, encoder_num_attention_heads} Mask to nullify selected heads of the self-attention blocks in the encoder. &quot;input_embeddings&quot; - {batch_size, sequence_length, hidden_size} Embedded representation of &quot;input_ids&quot; , which can be specified for more control over how &quot;input_ids&quot; are embedded than the model's internal embedding lookup. If &quot;input_embeddings&quot; are present, then &quot;input_ids&quot; will be ignored. &quot;decoder_input_ids&quot; - {batch_size, target_sequence_length} Indices of decoder input sequence tokens in the vocabulary. If not present and &quot;input_ids&quot; is, it will be generated by shifting each token in &quot;input_ids&quot; to the right once. &quot;decoder_attention_mask&quot; - {batch_size, target_sequence_length} Mask indicating which decoder tokens to attend to. This is used to ignore padding tokens, which are added when processing a batch of sequences with different length. &quot;decoder_position_ids&quot; - {batch_size, target_sequence_length} Indices of positions of each decoder input sequence tokens in the position embeddings. &quot;decoder_attention_head_mask&quot; - {decoder_num_blocks, decoder_num_attention_heads} Mask to nullify selected heads of the self-attention blocks in the decoder. &quot;decoder_input_embeddings&quot; - {batch_size, sequence_length, hidden_size} Embedded representation of &quot;decoder_input_ids&quot; , which can be specified for more control over how &quot;decoder_input_ids&quot; are embedded than the model's internal embedding lookup. If &quot;decoder_input_embeddings&quot; are present, then &quot;decoder_input_ids&quot; will be ignored. &quot;encoder_hidden_state&quot; - {batch_size, sequence_length, hidden_size} Last hidden state output from the encoder. This hidden state is used in cross-attention blocks in the decoder. If specified, the model will skip the encoding process and use this value directly for cross-attentions in the decoder. &quot;cross_attention_head_mask&quot; - {decoder_num_blocks, decoder_num_attention_heads} Mask to nullify selected heads of the cross-attention blocks in the decoder with shape. &quot;cache&quot; A container with cached layer results used to speed up sequential decoding (autoregression). With cache, certain hidden states are taken from the cache, rather than recomputed on every decoding pass. The cache should be treated as opaque and initialized with Bumblebee.Text.Generation.init_cache/4 . Exceptions The :for_causal_language_modeling model is just the decoder part and accepts the following inputs instead: &quot;input_ids&quot; , &quot;attention_mask&quot; , &quot;position_ids&quot; , &quot;attention_head_mask&quot; , &quot;input_embeddings&quot; , &quot;encoder_hidden_state&quot; , &quot;encoder_attention_mask&quot; , &quot;cross_attention_head_mask&quot; , &quot;cache&quot; . Configuration :vocab_size - the vocabulary size of the token embedding. This corresponds to the number of distinct tokens that can be represented in model input and output . Defaults to 50265 :max_positions - the vocabulary size of the position embedding. This corresponds to the maximum sequence length that this model can process. Typically this is set to a large value just in case, such as 512, 1024 or 2048 . Defaults to 1024 :hidden_size - the dimensionality of hidden layers. Defaults to 1024 :encoder_num_blocks - the number of Transformer blocks in the encoder. Defaults to 12 :decoder_num_blocks - the number of Transformer blocks in the decoder. Defaults to 12 :encoder_num_attention_heads - the number of attention heads for each attention layer in the encoder. Defaults to 16 :decoder_num_attention_heads - the number of attention heads for each attention layer in the decoder. Defaults to 16 :encoder_intermediate_size - the dimensionality of the intermediate layer in the transformer feed-forward network (FFN) in the encoder. Defaults to 4096 :decoder_intermediate_size - the dimensionality of the intermediate layer in the transformer feed-forward network (FFN) in the decoder. Defaults to 4096 :scale_embedding - scale embeddings by dividing by sqrt(hidden_size). Defaults to false :activation - the activation function. Defaults to :gelu :dropout_rate - the dropout rate for encoder and decoder. Defaults to 0.1 :attention_dropout_rate - the dropout rate for attention weights. Defaults to 0.0 :activation_dropout_rate - the dropout rate for activations inside fully connected layers. Defaults to 0.0 :classifier_dropout_rate - the dropout rate for the classification head. Defaults to 0.0 :initializer_scale - the standard deviation of the normal initializer used for initializing kernel parameters. Defaults to 0.02 :output_hidden_states - whether the model should return all hidden states. Defaults to false :output_attentions - whether the model should return all attentions. Defaults to false :num_labels - the number of labels to use in the last layer for the classification task. Defaults to 2 :id_to_label - a map from class index to label. Defaults to %{}","ref":"Bumblebee.Text.Mbart.html","title":"Bumblebee.Text.Mbart","type":"module"},{"doc":"RoBERTa model family. Architectures :base - plain RoBERTa without any head on top :for_masked_language_modeling - RoBERTa with a language modeling head. The head returns logits for each token in the original sequence :for_sequence_classification - RoBERTa with a sequence classification head. The head returns logits corresponding to possible classes :for_token_classification - RoBERTa with a token classification head. The head returns logits for each token in the original sequence :for_question_answering - RoBERTa with a span classification head. The head returns logits for the span start and end positions :for_multiple_choice - RoBERTa with a multiple choice prediction head. Each input in the batch consists of several sequences to choose from and the model returns logits corresponding to those choices :for_causal_language_modeling - RoBERTa working as a decoder with a language modeling head. The head returns logits for each token in the original sequence Inputs &quot;input_ids&quot; - {batch_size, sequence_length} Indices of input sequence tokens in the vocabulary. &quot;attention_mask&quot; - {batch_size, sequence_length} Mask indicating which tokens to attend to. This is used to ignore padding tokens, which are added when processing a batch of sequences with different length. &quot;token_type_ids&quot; - {batch_size, sequence_length} Mask distinguishing groups in the input sequence. This is used in when the input sequence is a semantically a pair of sequences. &quot;position_ids&quot; - {batch_size, sequence_length} Indices of positions of each input sequence tokens in the position embeddings. &quot;attention_head_mask&quot; - {num_blocks, num_attention_heads} Mask to nullify selected heads of the self-attention blocks in the encoder. Exceptions The :for_multiple_choice model accepts groups of sequences, so the expected sequence shape is {batch_size, num_choices, sequence_length} . The :for_causal_language_modeling model is a decoder and accepts the following additional inputs: &quot;encoder_hidden_state&quot; , &quot;encoder_attention_mask&quot; , &quot;cross_attention_head_mask&quot; , &quot;cache&quot; . Configuration :vocab_size - the vocabulary size of the token embedding. This corresponds to the number of distinct tokens that can be represented in model input and output . Defaults to 30522 :max_positions - the vocabulary size of the position embedding. This corresponds to the maximum sequence length that this model can process. Typically this is set to a large value just in case, such as 512, 1024 or 2048 . Defaults to 512 :max_token_types - the vocabulary size of the token type embedding (also referred to as segment embedding). This corresponds to how many different token groups can be distinguished in the input . Defaults to 2 :hidden_size - the dimensionality of hidden layers. Defaults to 768 :num_blocks - the number of Transformer blocks in the encoder. Defaults to 12 :num_attention_heads - the number of attention heads for each attention layer in the encoder. Defaults to 12 :intermediate_size - the dimensionality of the intermediate layer in the transformer feed-forward network (FFN) in the encoder. Defaults to 3072 :activation - the activation function. Defaults to :gelu :dropout_rate - the dropout rate for embedding and encoder. Defaults to 0.1 :attention_dropout_rate - the dropout rate for attention weights. Defaults to 0.1 :classifier_dropout_rate - the dropout rate for the classification head. If not specified, the value of :dropout_rate is used instead :layer_norm_epsilon - the epsilon used by the layer normalization layers. Defaults to 1.0e-12 :initializer_range - the standard deviation of the normal initializer used for initializing kernel parameters. Defaults to 0.02 :output_hidden_states - whether the model should return all hidden states. Defaults to false :output_attentions - whether the model should return all attentions. Defaults to false :num_labels - the number of labels to use in the last layer for the classification task. Defaults to 2 :id_to_label - a map from class index to label. Defaults to %{} :use_cross_attention - whether cross-attention layers should be added to the model.This is only relevant for decoder models. Defaults to false","ref":"Bumblebee.Text.Roberta.html","title":"Bumblebee.Text.Roberta","type":"module"},{"doc":"T5 model family. Architectures :base - plain T5 without any head on top :for_conditional_generation - T5 with a language modeling head. The head returns logits for each token in the original sequence :encoder - just the encoder part of the base model Inputs &quot;input_ids&quot; - {batch_size, sequence_length} Indices of input sequence tokens in the vocabulary. &quot;attention_mask&quot; - {batch_size, sequence_length} Mask indicating which tokens to attend to. This is used to ignore padding tokens, which are added when processing a batch of sequences with different length. &quot;attention_head_mask&quot; - {encoder_num_blocks, encoder_num_attention_heads} Mask to nullify selected heads of the self-attention blocks in the encoder. &quot;input_embeddings&quot; - {batch_size, sequence_length, hidden_size} Embedded representation of &quot;input_ids&quot; , which can be specified for more control over how &quot;input_ids&quot; are embedded than the model's internal embedding lookup. If &quot;input_embeddings&quot; are present, then &quot;input_ids&quot; will be ignored. &quot;decoder_input_ids&quot; - {batch_size, target_sequence_length} Indices of decoder input sequence tokens in the vocabulary. If not present and &quot;input_ids&quot; is, it will be generated by shifting each token in &quot;input_ids&quot; to the right once. &quot;decoder_attention_mask&quot; - {batch_size, target_sequence_length} Mask indicating which decoder tokens to attend to. This is used to ignore padding tokens, which are added when processing a batch of sequences with different length. &quot;decoder_attention_head_mask&quot; - {decoder_num_blocks, decoder_num_attention_heads} Mask to nullify selected heads of the self-attention blocks in the decoder. &quot;decoder_input_embeddings&quot; - {batch_size, sequence_length, hidden_size} Embedded representation of &quot;decoder_input_ids&quot; , which can be specified for more control over how &quot;decoder_input_ids&quot; are embedded than the model's internal embedding lookup. If &quot;decoder_input_embeddings&quot; are present, then &quot;decoder_input_ids&quot; will be ignored. &quot;encoder_hidden_state&quot; - {batch_size, sequence_length, hidden_size} Last hidden state output from the encoder. This hidden state is used in cross-attention blocks in the decoder. If specified, the model will skip the encoding process and use this value directly for cross-attentions in the decoder. &quot;cross_attention_head_mask&quot; - {decoder_num_blocks, decoder_num_attention_heads} Mask to nullify selected heads of the cross-attention blocks in the decoder with shape. &quot;cache&quot; A container with cached layer results used to speed up sequential decoding (autoregression). With cache, certain hidden states are taken from the cache, rather than recomputed on every decoding pass. The cache should be treated as opaque and initialized with Bumblebee.Text.Generation.init_cache/4 . Configuration :vocab_size - the vocabulary size of the token embedding. This corresponds to the number of distinct tokens that can be represented in model input and output . Defaults to 32128 :tie_word_embeddings - whether or not to tie encoder and decoder token embedding . Defaults to true :hidden_size - the dimensionality of hidden layers. Defaults to 512 :attention_head_size - the size of the key, value, and query projection per attention head. Defaults to 64 :encoder_num_blocks - the number of Transformer blocks in the encoder. Defaults to 6 :decoder_num_blocks - the number of Transformer blocks in the decoder. Defaults to 6 :encoder_num_attention_heads - the number of attention heads for each attention layer in the encoder. Defaults to 8 :decoder_num_attention_heads - the number of attention heads for each attention layer in the decoder. Defaults to 8 :activation - the activation function. Defaults to :relu :ffn_gated_activation - whether to use a gated variant of the activation function in the feed-forward network (FFN). Defaults to false :dropout_rate - the dropout rate for encoder and decoder. Defaults to 0.1 :initializer_scale - the standard deviation of the normal initializer used for initializing kernel parameters. Defaults to 1.0 :layer_norm_epsilon - the epsilon used by the layer normalization layers. Defaults to 1.0e-6 :output_hidden_states - whether the model should return all hidden states. Defaults to false :output_attentions - whether the model should return all attentions. Defaults to false :num_labels - the number of labels to use in the last layer for the classification task. Defaults to 2 :id_to_label - a map from class index to label. Defaults to %{}","ref":"Bumblebee.Text.T5.html","title":"Bumblebee.Text.T5","type":"module"},{"doc":"The BLIP model for image encoding. Architectures :base - the base image model Inputs &quot;pixel_values&quot; - {batch_size, image_size, image_size, num_channels} Featurized image pixel values. Configuration :image_size - the size of the input spatial dimensions. Defaults to 384 :num_channels - the number of channels in the input. Defaults to 3 :patch_size - the size of the patch spatial dimensions. Defaults to 16 :hidden_size - the dimensionality of hidden layers. Defaults to 768 :num_blocks - the number of Transformer blocks in the encoder. Defaults to 12 :num_attention_heads - the number of attention heads for each attention layer in the encoder. Defaults to 12 :activation - the activation function. Defaults to :gelu :attention_dropout_rate - the dropout rate for attention weights. Defaults to 0.0 :layer_norm_epsilon - the epsilon used by the layer normalization layers. Defaults to 1.0e-5 :initializer_scale - the standard deviation of the normal initializer used for initializing kernel parameters. Defaults to 0.02 :output_hidden_states - whether the model should return all hidden states. Defaults to false :output_attentions - whether the model should return all attentions. Defaults to false","ref":"Bumblebee.Vision.BlipVision.html","title":"Bumblebee.Vision.BlipVision","type":"module"},{"doc":"The CLIP model for image encoding. Architectures :base - the base image model Inputs &quot;pixel_values&quot; - {batch_size, image_size, image_size, num_channels} Featurized image pixel values. Configuration :image_size - the size of the input spatial dimensions. Defaults to 224 :num_channels - the number of channels in the input. Defaults to 3 :patch_size - the size of the patch spatial dimensions. Defaults to 32 :hidden_size - the dimensionality of hidden layers. Defaults to 768 :num_blocks - the number of Transformer blocks in the encoder. Defaults to 12 :num_attention_heads - the number of attention heads for each attention layer in the encoder. Defaults to 12 :activation - the activation function. Defaults to :quick_gelu :attention_dropout_rate - the dropout rate for attention weights. Defaults to 0.0 :layer_norm_epsilon - the epsilon used by the layer normalization layers. Defaults to 1.0e-5 :output_hidden_states - whether the model should return all hidden states. Defaults to false :output_attentions - whether the model should return all attentions. Defaults to false","ref":"Bumblebee.Vision.ClipVision.html","title":"Bumblebee.Vision.ClipVision","type":"module"},{"doc":"ConvNeXT model family. Architectures :base - plain ConvNeXT without any head on top :for_image_classification - ConvNeXT with a classification head. The head consists of a single dense layer on top of the pooled features Inputs &quot;pixel_values&quot; - {batch_size, height, width, num_channels} Featurized image pixel values (224x224). Configuration :num_channels - the number of channels in the input. Defaults to 3 :patch_size - the size of the patch spatial dimensions. Defaults to 4 :hidden_sizes - the dimensionality of hidden layers at each stage. Defaults to [96, 192, 384, 768] :depths - the depth (number of residual blocks) at each stage. Defaults to [3, 3, 9, 3] :activation - the activation function. Defaults to :gelu :scale_initial_value - the initial value for scaling layers. Defaults to 1.0e-6 :drop_path_rate - the drop path rate used to for stochastic depth. Defaults to 0.0 :layer_norm_epsilon - the epsilon used by the layer normalization layers. Defaults to 1.0e-12 :initializer_scale - the standard deviation of the normal initializer used for initializing kernel parameters. Defaults to 0.02 :output_hidden_states - whether the model should return all hidden states. Defaults to false :num_labels - the number of labels to use in the last layer for the classification task. Defaults to 2 :id_to_label - a map from class index to label. Defaults to %{} References A ConvNet for the 2020s","ref":"Bumblebee.Vision.ConvNext.html","title":"Bumblebee.Vision.ConvNext","type":"module"},{"doc":"DeiT model family. Architectures :base - plain DeiT without any head on top :for_image_classification - DeiT with a classification head. The head consists of two dense layers on top of the final hidden state of the CLS token :for_image_classification_with teacher - DeiT with a classification head. The head consists of two dense layers on top of the final hidden state of the CLS token and the final hidden state of the distillation token :for_masked_image_modeling - DEiT with a language modeling head on top for predicting visual tokens Inputs &quot;pixel_values&quot; - {batch_size, image_size, image_size, num_channels} Featurized image pixel values. &quot;patch_mask&quot; - {batch_size, num_patches} Mask to nullify selected embedded patches. Configuration :image_size - the size of the input spatial dimensions. Defaults to 224 :num_channels - the number of channels in the input. Defaults to 3 :patch_size - the size of the patch spatial dimensions. Defaults to 16 :hidden_size - the dimensionality of hidden layers. Defaults to 768 :num_blocks - the number of Transformer blocks in the encoder. Defaults to 12 :num_attention_heads - the number of attention heads for each attention layer in the encoder. Defaults to 12 :use_qkv_bias - whether to use bias in query, key, and value projections. Defaults to true :activation - the activation function. Defaults to :gelu :dropout_rate - the dropout rate for encoder and decoder. Defaults to 0.0 :attention_dropout_rate - the dropout rate for attention weights. Defaults to 0.0 :layer_norm_epsilon - the epsilon used by the layer normalization layers. Defaults to 1.0e-12 :initializer_scale - the standard deviation of the normal initializer used for initializing kernel parameters. Defaults to 0.02 :output_hidden_states - whether the model should return all hidden states. Defaults to false :output_attentions - whether the model should return all attentions. Defaults to false :num_labels - the number of labels to use in the last layer for the classification task. Defaults to 2 :id_to_label - a map from class index to label. Defaults to %{} References An Image is Worth 16x16 Words: Transformers for Image Recognition at Scale","ref":"Bumblebee.Vision.Deit.html","title":"Bumblebee.Vision.Deit","type":"module"},{"doc":"ResNet model family. Architectures :base - plain ResNet without any head on top :for_image_classification - ResNet with a classification head. The head consists of a single dense layer on top of the pooled features and it returns logits corresponding to possible classes Inputs &quot;pixel_values&quot; - {batch_size, height, width, num_channels} Featurized image pixel values (224x224). Configuration :num_channels - the number of channels in the input. Defaults to 3 :embedding_size - the dimensionality of the embedding layer. Defaults to 64 :hidden_sizes - the dimensionality of hidden layers at each stage. Defaults to [256, 512, 1024, 2048] :depths - the depth (number of residual blocks) at each stage. Defaults to [3, 4, 6, 3] :residual_block_type - the residual block to use, either :basic (used for smaller models, like ResNet-18 or ResNet-34) or :bottleneck (used for larger models like ResNet-50 and above) . Defaults to :bottleneck :activation - the activation function. Defaults to :relu :downsample_in_first_stage - whether the first stage should downsample the inputs using a stride of 2. Defaults to false :output_hidden_states - whether the model should return all hidden states. Defaults to false :num_labels - the number of labels to use in the last layer for the classification task. Defaults to 2 :id_to_label - a map from class index to label. Defaults to %{}","ref":"Bumblebee.Vision.ResNet.html","title":"Bumblebee.Vision.ResNet","type":"module"},{"doc":"ViT model family. Architectures :base - plain ViT without any head on top :for_image_classification - ViT with a classification head. The head consists of a single dense layer on top of the pooled features :for_masked_image_modeling - ViT with a language modeling head on top for predicting visual tokens Inputs &quot;pixel_values&quot; - {batch_size, image_size, image_size, num_channels} Featurized image pixel values. &quot;patch_mask&quot; - {batch_size, num_patches} Mask to nullify selected embedded patches. Configuration :image_size - the size of the input spatial dimensions. Defaults to 224 :num_channels - the number of channels in the input. Defaults to 3 :patch_size - the size of the patch spatial dimensions. Defaults to 16 :hidden_size - the dimensionality of hidden layers. Defaults to 768 :num_blocks - the number of Transformer blocks in the encoder. Defaults to 12 :num_attention_heads - the number of attention heads for each attention layer in the encoder. Defaults to 12 :use_qkv_bias - whether to use bias in query, key, and value projections. Defaults to true :activation - the activation function. Defaults to :gelu :dropout_rate - the dropout rate for encoder and decoder. Defaults to 0.0 :attention_dropout_rate - the dropout rate for attention weights. Defaults to 0.0 :layer_norm_epsilon - the epsilon used by the layer normalization layers. Defaults to 1.0e-12 :initializer_scale - the standard deviation of the normal initializer used for initializing kernel parameters. Defaults to 0.02 :output_hidden_states - whether the model should return all hidden states. Defaults to false :output_attentions - whether the model should return all attentions. Defaults to false :num_labels - the number of labels to use in the last layer for the classification task. Defaults to 2 :id_to_label - a map from class index to label. Defaults to %{} References An Image is Worth 16x16 Words: Transformers for Image Recognition at Scale","ref":"Bumblebee.Vision.Vit.html","title":"Bumblebee.Vision.Vit","type":"module"},{"doc":"Whisper featurizer for audio data. Configuration :feature_size - the dimension of the extracted features. This corresponds to the number of Mel bins. Defaults to 80 :sampling_rate - the sampling rate at which the audio files should be digitally expressed in Hertz. Defaults to 16000 :num_seconds - the maximum duration of the audio sequence. This implies that the the maximum length of the input sequence is :num_seconds * :sampling_rate . Defaults to 30 :hop_length - the hop between consecutive overlapping windows for the STFT used to obtain Mel Frequency coefficients. Defaults to 160 :fft_length - the size of the fourier transform. Defaults to 400 :padding_value - the value used to pad the audio. Should correspond to silence. Defaults to 0.0","ref":"Bumblebee.Audio.WhisperFeaturizer.html","title":"Bumblebee.Audio.WhisperFeaturizer","type":"module"},{"doc":"ALBERT tokenizer.","ref":"Bumblebee.Text.AlbertTokenizer.html","title":"Bumblebee.Text.AlbertTokenizer","type":"module"},{"doc":"BART tokenizer.","ref":"Bumblebee.Text.BartTokenizer.html","title":"Bumblebee.Text.BartTokenizer","type":"module"},{"doc":"BERT tokenizer.","ref":"Bumblebee.Text.BertTokenizer.html","title":"Bumblebee.Text.BertTokenizer","type":"module"},{"doc":"Blenderbot tokenizer.","ref":"Bumblebee.Text.BlenderbotTokenizer.html","title":"Bumblebee.Text.BlenderbotTokenizer","type":"module"},{"doc":"Camembert tokenizer.","ref":"Bumblebee.Text.CamembertTokenizer.html","title":"Bumblebee.Text.CamembertTokenizer","type":"module"},{"doc":"CLIP tokenizer.","ref":"Bumblebee.Text.ClipTokenizer.html","title":"Bumblebee.Text.ClipTokenizer","type":"module"},{"doc":"DistilBERT tokenizer.","ref":"Bumblebee.Text.DistilbertTokenizer.html","title":"Bumblebee.Text.DistilbertTokenizer","type":"module"},{"doc":"GPT-2 tokenizer.","ref":"Bumblebee.Text.Gpt2Tokenizer.html","title":"Bumblebee.Text.Gpt2Tokenizer","type":"module"},{"doc":"GPT-NeoX tokenizer.","ref":"Bumblebee.Text.GptNeoXTokenizer.html","title":"Bumblebee.Text.GptNeoXTokenizer","type":"module"},{"doc":"LayoutLM tokenizer.","ref":"Bumblebee.Text.LayoutLmTokenizer.html","title":"Bumblebee.Text.LayoutLmTokenizer","type":"module"},{"doc":"Llama tokenizer.","ref":"Bumblebee.Text.LlamaTokenizer.html","title":"Bumblebee.Text.LlamaTokenizer","type":"module"},{"doc":"mBART tokenizer.","ref":"Bumblebee.Text.MbartTokenizer.html","title":"Bumblebee.Text.MbartTokenizer","type":"module"},{"doc":"RoBERTa tokenizer.","ref":"Bumblebee.Text.RobertaTokenizer.html","title":"Bumblebee.Text.RobertaTokenizer","type":"module"},{"doc":"T5 tokenizer.","ref":"Bumblebee.Text.T5Tokenizer.html","title":"Bumblebee.Text.T5Tokenizer","type":"module"},{"doc":"Whisper tokenizer.","ref":"Bumblebee.Text.WhisperTokenizer.html","title":"Bumblebee.Text.WhisperTokenizer","type":"module"},{"doc":"XLM-RoBERTa tokenizer.","ref":"Bumblebee.Text.XlmRobertaTokenizer.html","title":"Bumblebee.Text.XlmRobertaTokenizer","type":"module"},{"doc":"BLIP featurizer for image data. Configuration :resize - whether to resize (and optionally center crop) the input to the given :size . Defaults to true :size - the size to resize the input to. Either a single number or a {height, width} tuple. Only has an effect if :resize is true . Defaults to 384 :resize_method - the resizing method, either of :nearest , :bilinear , :bicubic , :lanczos3 , :lanczos5 . Defaults to :bicubic :normalize - whether or not to normalize the input with mean and standard deviation. Defaults to true :image_mean - the sequence of mean values for each channel, to be used when normalizing images. Defaults to [0.48145466, 0.4578275, 0.40821073] :image_std - the sequence of standard deviations for each channel, to be used when normalizing images. Defaults to [0.26862954, 0.26130258, 0.27577711]","ref":"Bumblebee.Vision.BlipFeaturizer.html","title":"Bumblebee.Vision.BlipFeaturizer","type":"module"},{"doc":"CLIP featurizer for image data. Configuration :resize - whether to resize (and optionally center crop) the input to the given :size . Defaults to true :size - the size to resize the input to. The image is resized to ( :size , :size ). Only has an effect if :resize is true . Defaults to 224 :resize_method - the resizing method, either of :nearest , :bilinear , :bicubic , :lanczos3 , :lanczos5 . Defaults to :bicubic :center_crop - whether to crop the input at the center. If the input size is smaller than :crop_size along any edge, the image is padded with zeros and then center cropped . Defaults to true :crop_size - the size to center crop the image to. Only has an effect if :center_crop is true . Defaults to 224 :normalize - whether or not to normalize the input with mean and standard deviation. Defaults to true :image_mean - the sequence of mean values for each channel, to be used when normalizing images. Defaults to [0.485, 0.456, 0.406] :image_std - the sequence of standard deviations for each channel, to be used when normalizing images. Defaults to [0.229, 0.224, 0.225]","ref":"Bumblebee.Vision.ClipFeaturizer.html","title":"Bumblebee.Vision.ClipFeaturizer","type":"module"},{"doc":"ConvNeXT featurizer for image data. Configuration :resize - whether to resize (and optionally center crop) the input to the given :size . Defaults to true :size - the size to resize the input to. If 384 or larger, the image is resized to ( :size , :size ). Otherwise, the shorter edge of the image is matched to :size / :crop_percentage , then image is cropped to :size . Only has an effect if :resize is true . Defaults to 224 :resize_method - the resizing method, either of :nearest , :bilinear , :bicubic , :lanczos3 , :lanczos5 . Defaults to :bicubic :crop_percentage - the percentage of the image to crop. Only has an effect if :resize is true and :size &lt; 384. Defaults to 0.875 :normalize - whether or not to normalize the input with mean and standard deviation. Defaults to true :image_mean - the sequence of mean values for each channel, to be used when normalizing images. Defaults to [0.485, 0.456, 0.406] :image_std - the sequence of standard deviations for each channel, to be used when normalizing images. Defaults to [0.229, 0.224, 0.225]","ref":"Bumblebee.Vision.ConvNextFeaturizer.html","title":"Bumblebee.Vision.ConvNextFeaturizer","type":"module"},{"doc":"DeiT featurizer for image data. Configuration :resize - whether to resize (and optionally center crop) the input to the given :size . Defaults to true :size - the size to resize the input to. Either a single number or a {height, width} tuple. Only has an effect if :resize is true . Defaults to 256 :resize_method - the resizing method, either of :nearest , :bilinear , :bicubic , :lanczos3 , :lanczos5 . Defaults to :bicubic :center_crop - whether to crop the input at the center. If the input size is smaller than :crop_size along any edge, the image is padded with zeros and then center cropped . Defaults to true :crop_size - the size to center crop the image to. Only has an effect if :center_crop is true . Defaults to 224 :normalize - whether or not to normalize the input with mean and standard deviation. Defaults to true :image_mean - the sequence of mean values for each channel, to be used when normalizing images. Defaults to [0.485, 0.456, 0.406] :image_std - the sequence of standard deviations for each channel, to be used when normalizing images. Defaults to [0.229, 0.224, 0.225]","ref":"Bumblebee.Vision.DeitFeaturizer.html","title":"Bumblebee.Vision.DeitFeaturizer","type":"module"},{"doc":"ViT featurizer for image data. Configuration :resize - whether to resize the input to the given :size . Defaults to true :size - the size to resize the input to. Either a single number or a {height, width} tuple. Only has an effect if :resize is true . Defaults to 224 :resize_method - the resizing method, either of :nearest , :bilinear , :bicubic , :lanczos3 , :lanczos5 . Defaults to :bilinear :normalize - whether or not to normalize the input with mean and standard deviation. Defaults to true :image_mean - the sequence of mean values for each channel, to be used when normalizing images. Defaults to [0.5, 0.5, 0.5] :image_std - the sequence of standard deviations for each channel, to be used when normalizing images. Defaults to [0.5, 0.5, 0.5]","ref":"Bumblebee.Vision.VitFeaturizer.html","title":"Bumblebee.Vision.VitFeaturizer","type":"module"},{"doc":"Denoising diffusion implicit models (DDIMs). This sampling method was proposed as a follow up to the original denoising diffusion probabilistic models (DDPMs) in order to heavily reduce the number of steps during inference. DDPMs model the diffusion process as a Markov chain; DDIMs generalize this considering non-Markovian diffusion processes that lead to the same objective. This enables a reverse process with many less samples, as compared to DDPMs, while using the same denoising model. DDIMs were shown to be a simple variant of pseudo numerical methods for diffusion models (PNDMs), see Bumblebee.Diffusion.PndmScheduler and the corresponding paper for more details. Configuration :num_train_steps - the number of diffusion steps used to train the model. Defaults to 1000 :beta_schedule - the beta schedule type, a mapping from a beta range to a sequence of betas for stepping the model. Either of :linear , :quadratic , or :squared_cosine . Defaults to :linear :beta_start - the start value for the beta schedule. Defaults to 0.0001 :beta_end - the end value for the beta schedule. Defaults to 0.02 :prediction_type - prediction type of the denoising model. Either of: :noise (default) - the model predicts the noise of the diffusion process :angular_velocity - the model predicts velocity in angular parameterization. See Section 2.4 in Imagen Video: High Definition Video Generation with Diffusion Models , then Section 4 in Progressive Distillation for Fast Sampling of Diffusion Models and Appendix D . Defaults to :noise :alpha_clip_strategy - each step $t$ uses the values of $\\bar{\\alpha}_t$ and $\\bar{\\alpha}_{t-1}$, however for $t = 0$ there is no previous alpha. The strategy can be either :one ($\\bar{\\alpha}_{t-1} = 1$) or :alpha_zero ($\\bar{\\alpha}_{t-1} = \\bar{\\alpha}_0$) . Defaults to :one :timesteps_offset - an offset added to the inference steps. You can use a combination of timesteps_offset: 1 and alpha_clip_strategy: :alpha_zero , so that the last step $t = 1$ uses $\\bar{\\alpha}_1$ and $\\bar{\\alpha}_0$, as done in stable diffusion . Defaults to 0 :clip_denoised_sample - whether to clip the predicted denoised sample ($x_0$ in Equation (12)) into $[-1, 1]$ for numerical stability. . Defaults to true :rederive_noise - whether the noise (output of the denoising model) should be re-derived at each step based on the predicted denoised sample ($x_0$) and the current sample. This technique is used in OpenAI GLIDE . Defaults to false :eta - a weight for the noise added in a denoising diffusion step. This scales the value of $\\sigma_t$ in Equation (12) in the original paper, as per Equation (16) . Defaults to 0.0 References Denoising Diffusion Implicit Models","ref":"Bumblebee.Diffusion.DdimScheduler.html","title":"Bumblebee.Diffusion.DdimScheduler","type":"module"},{"doc":"Pseudo numerical methods for diffusion models (PNDMs). The sampling is based on two numerical methods for solving ODE: the Runge-Kutta method (RK) and the linear multi-step method (LMS). The gradient at each step is computed according to either of these methods, however the transfer part (approximating the next sample based on current sample and gradient) is non-linear. Because of this property, the authors of the paper refer to them as pseudo numerical methods, denoted as PRK and PLMS respectively. Configuration :num_train_steps - the number of diffusion steps used to train the model. Defaults to 1000 :beta_schedule - the beta schedule type, a mapping from a beta range to a sequence of betas for stepping the model. Either of :linear , :quadratic , or :squared_cosine . Defaults to :linear :beta_start - the start value for the beta schedule. Defaults to 0.0001 :beta_end - the end value for the beta schedule. Defaults to 0.02 :alpha_clip_strategy - each step $t$ uses the values of $\\bar{\\alpha}_t$ and $\\bar{\\alpha}_{t-1}$, however for $t = 0$ there is no previous alpha. The strategy can be either :one ($\\bar{\\alpha}_{t-1} = 1$) or :alpha_zero ($\\bar{\\alpha}_{t-1} = \\bar{\\alpha}_0$) . Defaults to :one :timesteps_offset - an offset added to the inference steps. You can use a combination of timesteps_offset: 1 and alpha_clip_strategy: :alpha_zero , so that the last step $t = 1$ uses $\\bar{\\alpha}_1$ and $\\bar{\\alpha}_0$, as done in stable diffusion . Defaults to 0 :reduce_warmup - when true , the first few samples are computed using lower-order linear multi-step, rather than the Runge-Kutta method. This results in less forward passes of the model . Defaults to false References Pseudo Numerical Methods for Diffusion Models on Manifolds","ref":"Bumblebee.Diffusion.PndmScheduler.html","title":"Bumblebee.Diffusion.PndmScheduler","type":"module"},{"doc":"An interface for configurable entities. A module implementing this behaviour is expected to define a struct with configuration.","ref":"Bumblebee.Configurable.html","title":"Bumblebee.Configurable","type":"behaviour"},{"doc":"Configures the struct.","ref":"Bumblebee.Configurable.html#c:config/2","title":"Bumblebee.Configurable.config/2","type":"callback"},{"doc":"","ref":"Bumblebee.Configurable.html#t:t/0","title":"Bumblebee.Configurable.t/0","type":"type"},{"doc":"An interface for configuring and applying featurizers. A featurizer is used to convert raw data into model input. Every module implementing this behaviour is expected to also define a configuration struct.","ref":"Bumblebee.Featurizer.html","title":"Bumblebee.Featurizer","type":"behaviour"},{"doc":"Performs feature extraction on the given input.","ref":"Bumblebee.Featurizer.html#c:apply/3","title":"Bumblebee.Featurizer.apply/3","type":"callback"},{"doc":"","ref":"Bumblebee.Featurizer.html#t:t/0","title":"Bumblebee.Featurizer.t/0","type":"type"},{"doc":"An interface for configuring and building models based on the same architecture. Every module implementing this behaviour is expected to also define a configuration struct.","ref":"Bumblebee.ModelSpec.html","title":"Bumblebee.ModelSpec","type":"behaviour"},{"doc":"Returns the list of supported model architectures.","ref":"Bumblebee.ModelSpec.html#c:architectures/0","title":"Bumblebee.ModelSpec.architectures/0","type":"callback"},{"doc":"Builds a template input for the model. The template is used to compile the model when initializing parameters.","ref":"Bumblebee.ModelSpec.html#c:input_template/1","title":"Bumblebee.ModelSpec.input_template/1","type":"callback"},{"doc":"Builds an Axon model according to the given configuration.","ref":"Bumblebee.ModelSpec.html#c:model/1","title":"Bumblebee.ModelSpec.model/1","type":"callback"},{"doc":"","ref":"Bumblebee.ModelSpec.html#t:t/0","title":"Bumblebee.ModelSpec.t/0","type":"type"},{"doc":"An interface for configuring and using schedulers. A scheduler defines a sampling method, usually used for multi-step denoising process, as in stable diffusion. Every module implementing this behaviour is expected to also define a configuration struct. Context Imagine a denoising model trained in 1000 steps. During training, we take some original data and add random noise 1000 times, this way we obtain 1000 steps with increasing level of noise. Then, the model learns to predict noise at each timestep, given data at that step (sample) and the timestep. Once such model is trained, we can obtain brand new data (such as image) by generating random data and denoising it with our model in 1000 steps. Doing 1000 forward passes of the model for a single generation can be expensive, hence multiple methods have been developed to reduce the number of steps during denoising, with no changes to the model. Each method specifies a subset of the original timesteps, at each timestep we need to do a forward pass of the model (or possibly a few), then the method extrapolates the sample to the next selected timestep, possibly skipping a lot of timesteps in between. Note on wording Throughout the docs and APIs the word &quot;steps&quot; refers to diffusion steps, whereas &quot;timesteps&quot; is more specific and refers to the exact values $t$ (points in time).","ref":"Bumblebee.Scheduler.html","title":"Bumblebee.Scheduler","type":"behaviour"},{"doc":"Initializes state for a new scheduler loop. Returns a pair of {state, timesteps} , where state is an opaque Nx.Container and timesteps is a tensor with the subsequent timesteps for model forward pass.","ref":"Bumblebee.Scheduler.html#c:init/3","title":"Bumblebee.Scheduler.init/3","type":"callback"},{"doc":"Predicts sample at the previous timestep. Takes the current sample and prediction (usually noise) returned by the model at the current timestep. Returns {state, prev_sample} , where state is the updated state and prev_sample is the predicted sample at the previous timestep.","ref":"Bumblebee.Scheduler.html#c:step/4","title":"Bumblebee.Scheduler.step/4","type":"callback"},{"doc":"","ref":"Bumblebee.Scheduler.html#t:state/0","title":"Bumblebee.Scheduler.state/0","type":"type"},{"doc":"","ref":"Bumblebee.Scheduler.html#t:t/0","title":"Bumblebee.Scheduler.t/0","type":"type"},{"doc":"An interface for language models supporting sequence generation.","ref":"Bumblebee.Text.Generation.html","title":"Bumblebee.Text.Generation","type":"behaviour"},{"doc":"Builds a numerical definition that generates sequences of tokens using the given language model. The model should be either a decoder or an encoder-decoder. The tokens are generated by iterative inference using the decoder (autoregression), until the termination criteria are met. In case of encoder-decoder models, the corresponding encoder is run only once and the intermediate state is reused during all iterations. The generation is controlled by a number of options given as %Bumblebee.Text.GenerationConfig{} , see the corresponding docs for more details. Options :seed - random seed to use when sampling. By default the current timestamp is used","ref":"Bumblebee.Text.Generation.html#build_generate/4","title":"Bumblebee.Text.Generation.build_generate/4","type":"function"},{"doc":"Initializes an opaque cache input for iterative inference.","ref":"Bumblebee.Text.Generation.html#init_cache/4","title":"Bumblebee.Text.Generation.init_cache/4","type":"function"},{"doc":"Initializes an opaque cache input for iterative inference.","ref":"Bumblebee.Text.Generation.html#c:init_cache/4","title":"Bumblebee.Text.Generation.init_cache/4","type":"callback"},{"doc":"Calls fun for every batched tensor in the cache.","ref":"Bumblebee.Text.Generation.html#traverse_cache/3","title":"Bumblebee.Text.Generation.traverse_cache/3","type":"function"},{"doc":"Traverses all batched tensors in the cache. This function is used when the cache needs to be inflated or deflated for a different batch size.","ref":"Bumblebee.Text.Generation.html#c:traverse_cache/3","title":"Bumblebee.Text.Generation.traverse_cache/3","type":"callback"},{"doc":"","ref":"Bumblebee.Text.Generation.html#t:cache/0","title":"Bumblebee.Text.Generation.cache/0","type":"type"},{"doc":"An interface for configuring and applying tokenizers. A tokenizer is used to convert raw text data into model input. Every module implementing this behaviour is expected to also define a configuration struct.","ref":"Bumblebee.Tokenizer.html","title":"Bumblebee.Tokenizer","type":"behaviour"},{"doc":"Performs tokenization and encoding on the given input.","ref":"Bumblebee.Tokenizer.html#c:apply/3","title":"Bumblebee.Tokenizer.apply/3","type":"callback"},{"doc":"Decodes a list of token ids into a sentence.","ref":"Bumblebee.Tokenizer.html#decode/2","title":"Bumblebee.Tokenizer.decode/2","type":"function"},{"doc":"Decodes a list of token ids into a sentence.","ref":"Bumblebee.Tokenizer.html#c:decode/2","title":"Bumblebee.Tokenizer.decode/2","type":"callback"},{"doc":"Converts the given token id the corresponding token.","ref":"Bumblebee.Tokenizer.html#id_to_token/2","title":"Bumblebee.Tokenizer.id_to_token/2","type":"function"},{"doc":"Converts the given token id the corresponding token.","ref":"Bumblebee.Tokenizer.html#c:id_to_token/2","title":"Bumblebee.Tokenizer.id_to_token/2","type":"callback"},{"doc":"Returns a special token by name.","ref":"Bumblebee.Tokenizer.html#special_token/2","title":"Bumblebee.Tokenizer.special_token/2","type":"function"},{"doc":"Returns id of a special token by name.","ref":"Bumblebee.Tokenizer.html#special_token_id/2","title":"Bumblebee.Tokenizer.special_token_id/2","type":"function"},{"doc":"Returns a map with special tokens.","ref":"Bumblebee.Tokenizer.html#c:special_tokens/1","title":"Bumblebee.Tokenizer.special_tokens/1","type":"callback"},{"doc":"Converts the given token into the corresponding numeric id.","ref":"Bumblebee.Tokenizer.html#token_to_id/2","title":"Bumblebee.Tokenizer.token_to_id/2","type":"function"},{"doc":"Converts the given token into the corresponding numeric id.","ref":"Bumblebee.Tokenizer.html#c:token_to_id/2","title":"Bumblebee.Tokenizer.token_to_id/2","type":"callback"},{"doc":"","ref":"Bumblebee.Tokenizer.html#t:input/0","title":"Bumblebee.Tokenizer.input/0","type":"type"},{"doc":"A type corresponding to a special token in the vocabulary. Common types :bos - a token representing the beginning of a sentence :eos - a token representing the end of a sentence :unk - a token representing an out-of-vocabulary token :sep - a token separating two different sentences in the same input :pad - a token added when processing a batch of sequences with different length :cls - a token representing the class of the input :mask - a token representing a masked token, used for masked language modeling tasks","ref":"Bumblebee.Tokenizer.html#t:special_token_type/0","title":"Bumblebee.Tokenizer.special_token_type/0","type":"type"},{"doc":"","ref":"Bumblebee.Tokenizer.html#t:t/0","title":"Bumblebee.Tokenizer.t/0","type":"type"},{"doc":"","ref":"Bumblebee.Tokenizer.html#t:token/0","title":"Bumblebee.Tokenizer.token/0","type":"type"},{"doc":"","ref":"Bumblebee.Tokenizer.html#t:token_id/0","title":"Bumblebee.Tokenizer.token_id/0","type":"type"},{"doc":"A set of configuration options controlling text generation. This struct is expected by Bumblebee.Text.Generation.build_generate/3 . Configuration Options controlling length :max_new_tokens - the maximum number of tokens to be generated, ignoring the number of tokens in the prompt. Defaults to 20 :min_new_tokens - the minimum number of tokens to be generated, ignoring the number of tokens in the prompt :max_length - the maximum length of the sequence to be generated. Note that this length includes the length of the input prompt (including padding). In general, prefer :max_new_tokens , which ignores the number of tokens in the prompt :min_length - the minimum length of the sequence to be generated. Note that this length includes the length of the input prompt (including padding). In general, prefer :min_new_tokens , which ignores the number of tokens in the prompt Options controlling strategy :strategy - the method deciding how tokens are selected, it has a significant impact on the quality of the generated sequence. Should be a map with :type and strategy-specific options. :greedy_search - the most straightforward approach, where in every iteration the most probable token (as given by the model) is taken. Example: %{type: :greedy_search} . :contrastive_search - state-of-the-art decoding method, capable of producing high quality, coherent sequences. The results are deterministic. See this article for more details. :top_k (required) - the number of highest probability vocabulary tokens considered as a continuation :alpha (required) - the weight of degeneration penalty. It balances the model confidence and the penalty Example: %{type: :contrastive_search, top_k: 4, alpha: 0.6} . :multinomial_sampling - this method samples tokens according to the probability distribution given by the model. The results are nondeterministic, unless a seed is specified. :top_k (optional) - when specified, restricts sampling to top-k most probable candidates :top_p (optional) - when specified, restricts sampling to tokens which probabilities add up to top-p . Defaults to %{type: :greedy_search} Options controlling generated tokens :decoder_start_token_id - the id of the initial token when generating from scratch, in case of encoder-decoder models :forced_bos_token_id - the id of the token to force as the first generated token :forced_eos_token_id - the id of the token to force as the last generated token when :max_length is reached :forced_token_ids - a list of {index, token_id} pairs forcing token_id to appear at index in the generated sequence. Defaults to [] :no_repeat_ngram_length - when set, n-grams of the given length can occur only once in the generated sequence Special tokens used during generation :bos_token_id - the id of the beginning-of-sequence token :eos_token_id - the id of the end-of-sequence token :pad_token_id - the id of the padding token","ref":"Bumblebee.Text.GenerationConfig.html","title":"Bumblebee.Text.GenerationConfig","type":"module"},{"doc":"","ref":"Bumblebee.Text.GenerationConfig.html#t:t/0","title":"Bumblebee.Text.GenerationConfig.t/0","type":"type"},{"doc":"Mix . install ( [ { :bumblebee , github : &quot;elixir-nx/bumblebee&quot; } , { :nx , &quot;~&gt; 0.5.1&quot; } , { :exla , &quot;~&gt; 0.5.1&quot; } , { :axon , &quot;~&gt; 0.5.1&quot; } , { :kino , &quot;~&gt; 0.8.0&quot; } ] ) Nx . global_default_backend ( EXLA.Backend )","ref":"examples.html","title":"Examples","type":"extras"},{"doc":"In this notebook we go through a number of examples to get a quick overview of what Bumblebee brings to the table.","ref":"examples.html#introduction","title":"Examples - Introduction","type":"extras"},{"doc":"Let's start with image classification. First, we load a pre-trained ResNet-50 model from a HuggingFace repository. We also load the corresponding featurizer for preprocessing input images. { :ok , resnet } = Bumblebee . load_model ( { :hf , &quot;microsoft/resnet-50&quot; } ) { :ok , featurizer } = Bumblebee . load_featurizer ( { :hf , &quot;microsoft/resnet-50&quot; } ) :ok Next, we use the high-level API to build an end-to-end task definition on top of the model we just loaded. We will also need an image to work with, so let's show an image input. serving = Bumblebee.Vision . image_classification ( resnet , featurizer ) image_input = Kino.Input . image ( &quot;Image&quot; , size : { 224 , 224 } ) Bumblebee implements end-to-end tasks using Nx.Serving . With serving we can choose to either do a one-off run, or to start a supervised process that automatically batches multiple inference requests. Thanks to this abstraction we can do quick experimentation and then plug the task into a production app with minimal effort. In this case we will do the one-off run for the selected image: image = Kino.Input . read ( image_input ) # Build a tensor from the raw pixel data image = image . data |&gt; Nx . from_binary ( :u8 ) |&gt; Nx . reshape ( { image . height , image . width , 3 } ) Nx.Serving . run ( serving , image ) Manual inference Note that we are dealing with regular Axon models and the high-level API is just a convenience. If you need full control over the inference flow, you can do it manually. In this case, we would pass the image through the featurizer to get normalized model inputs, then we would run the model and finally extract the most probable label. inputs = Bumblebee . apply_featurizer ( featurizer , image ) outputs = Axon . predict ( resnet . model , resnet . params , inputs ) id = outputs . logits |&gt; Nx . argmax ( ) |&gt; Nx . to_number ( ) resnet . spec . id_to_label [ id ] You can try a number of other models, just replace the repository id with one of these: facebook/convnext-tiny-224 (ConvNeXT) google/vit-base-patch16-224 (ViT) facebook/deit-base-distilled-patch16-224 (DeiT)","ref":"examples.html#image-classification","title":"Examples - Image classification","type":"extras"},{"doc":"Now time for some text processing. Specifically, we want to fill in the missing word in a sentence. This time we load the BERT model together with a matching tokenizer. We will use the tokenizer to preprocess our text input. { :ok , bert } = Bumblebee . load_model ( { :hf , &quot;bert-base-uncased&quot; } ) { :ok , tokenizer } = Bumblebee . load_tokenizer ( { :hf , &quot;bert-base-uncased&quot; } ) serving = Bumblebee.Text . fill_mask ( bert , tokenizer ) text_input = Kino.Input . text ( &quot;Sentence with mask&quot; , default : &quot;The capital of [MASK] is Paris.&quot; ) text = Kino.Input . read ( text_input ) Nx.Serving . run ( serving , text ) Again, you can try other models, such as albert-base-v2 or roberta-base .","ref":"examples.html#fill-mask","title":"Examples - Fill-mask","type":"extras"},{"doc":"In this example we will analyze text sentiment. We will use the BERTweet model, trained to classify text into one of three categories: positive (POS), negative (NEG) or neutral (NEU). { :ok , bertweet } = Bumblebee . load_model ( { :hf , &quot;finiteautomata/bertweet-base-sentiment-analysis&quot; } ) { :ok , tokenizer } = Bumblebee . load_tokenizer ( { :hf , &quot;vinai/bertweet-base&quot; } ) serving = Bumblebee.Text . text_classification ( bertweet , tokenizer ) text_input = Kino.Input . text ( &quot;Text&quot; , default : &quot;This cat is so cute.&quot; ) Note: this time we need to load a matching tokenizer from a different repository. text = Kino.Input . read ( text_input ) Nx.Serving . run ( serving , text )","ref":"examples.html#text-classification","title":"Examples - Text classification","type":"extras"},{"doc":"In this section we look at token classification, more specifically named-entity recognition (NER), where the objective is to identify and categorize entities in text. We will once again use a fine-tuned BERT model. { :ok , bert } = Bumblebee . load_model ( { :hf , &quot;dslim/bert-base-NER&quot; } ) { :ok , tokenizer } = Bumblebee . load_tokenizer ( { :hf , &quot;bert-base-cased&quot; } ) serving = Bumblebee.Text . token_classification ( bert , tokenizer , aggregation : :same ) text_input = Kino.Input . text ( &quot;Text&quot; , default : &quot;Rachel Green works at Ralph Lauren in New York City in the sitcom Friends&quot; ) text = Kino.Input . read ( text_input ) Nx.Serving . run ( serving , text )","ref":"examples.html#named-entity-recognition","title":"Examples - Named-entity recognition","type":"extras"},{"doc":"Generation is where things get even more exciting. In this section w will use the extremely popular GPT-2 model to generate text continuation. Generation generally is an iterative process, where the model predicts the sentence token by token, adhering to some constraints. Again, we will make use of a higher-level API based on Nx.Serving . { :ok , gpt2 } = Bumblebee . load_model ( { :hf , &quot;gpt2&quot; } ) { :ok , tokenizer } = Bumblebee . load_tokenizer ( { :hf , &quot;gpt2&quot; } ) { :ok , generation_config } = Bumblebee . load_generation_config ( { :hf , &quot;gpt2&quot; } ) serving = Bumblebee.Text . generation ( gpt2 , tokenizer , generation_config ) text_input = Kino.Input . text ( &quot;Text&quot; , default : &quot;Yesterday, I was reading a book and&quot; ) text = Kino.Input . read ( text_input ) Nx.Serving . run ( serving , text ) There is also gpt2-medium and gpt2-large - heavier versions of the model with much more parameters.","ref":"examples.html#text-generation","title":"Examples - Text generation","type":"extras"},{"doc":"Another text-related task is question answering, where the objective is to retrieve the answer to a question based on a given text. We will work with a RoBERTa model trained to do just that. { :ok , roberta } = Bumblebee . load_model ( { :hf , &quot;deepset/roberta-base-squad2&quot; } ) { :ok , tokenizer } = Bumblebee . load_tokenizer ( { :hf , &quot;roberta-base&quot; } ) serving = Bumblebee.Text . question_answering ( roberta , tokenizer ) question_input = Kino.Input . text ( &quot;Question&quot; , default : &quot;Which name is also used to describe the Amazon rainforest in English?&quot; ) context_input = Kino.Input . textarea ( &quot;Context&quot; , default : ~s/The Amazon rainforest (Portuguese: Floresta Amazônica or Amazônia; Spanish: Selva Amazónica, Amazonía or usually Amazonia; French: Forêt amazonienne; Dutch: Amazoneregenwoud), also known in English as Amazonia or the Amazon Jungle, is a moist broadleaf forest that covers most of the Amazon basin of South America. This basin encompasses 7,000,000 square kilometres (2,700,000 sq mi), of which 5,500,000 square kilometres (2,100,000 sq mi) are covered by the rainforest. This region includes territory belonging to nine nations. The majority of the forest is contained within Brazil, with 60% of the rainforest, followed by Peru with 13%, Colombia with 10%, and with minor amounts in Venezuela, Ecuador, Bolivia, Guyana, Suriname and French Guiana. States or departments in four nations contain &quot;Amazonas&quot; in their names. The Amazon represents over half of the planet&#39;s remaining rainforests, and comprises the largest and most biodiverse tract of tropical rainforest in the world, with an estimated 390 billion individual trees divided into 16,000 species./ ) Kino.Layout . grid ( [ question_input , context_input ] ) question = Kino.Input . read ( question_input ) context = Kino.Input . read ( context_input ) Nx.Serving . run ( serving , %{ question : question , context : context } )","ref":"examples.html#question-answering","title":"Examples - Question answering","type":"extras"},{"doc":"The examples we covered should give you a good idea of what Bumblebee is about. We are excited about enabling easy access to the pre-trained, powerful deep learning models in Elixir. We are actively working on adding more models and high-level APIs, so stay tuned 🚀","ref":"examples.html#final-notes","title":"Examples - Final notes","type":"extras"},{"doc":"Mix . install ( [ { :bumblebee , &quot;~&gt; 0.3.0&quot; } , { :nx , &quot;~&gt; 0.5.1&quot; } , { :exla , &quot;~&gt; 0.5.1&quot; } , { :kino , &quot;~&gt; 0.8.0&quot; } ] ) Nx . global_default_backend ( EXLA.Backend )","ref":"stable_diffusion.html","title":"Stable Diffusion","type":"extras"},{"doc":"Stable Diffusion is a latent text-to-image diffusion model, primarily used to generate images based on a text prompt. Ever since it became open-source , the research, applications and tooling around it exploded. You can find a ton of resources and examples online, meanwhile let's see how to run Stable Diffusion using Bumblebee! Note: Stable Diffusion is a very involved model, so the generation can take a long time if you run it on a CPU. Also, running on the GPU currently requires at least 10 GB of VRAM.","ref":"stable_diffusion.html#introduction","title":"Stable Diffusion - Introduction","type":"extras"},{"doc":"Stable Diffusion is composed of several separate models and preprocessors, so we will load all of them. repository_id = &quot;CompVis/stable-diffusion-v1-4&quot; { :ok , tokenizer } = Bumblebee . load_tokenizer ( { :hf , &quot;openai/clip-vit-large-patch14&quot; } ) { :ok , clip } = Bumblebee . load_model ( { :hf , repository_id , subdir : &quot;text_encoder&quot; } ) { :ok , unet } = Bumblebee . load_model ( { :hf , repository_id , subdir : &quot;unet&quot; } , params_filename : &quot;diffusion_pytorch_model.bin&quot; ) { :ok , vae } = Bumblebee . load_model ( { :hf , repository_id , subdir : &quot;vae&quot; } , architecture : :decoder , params_filename : &quot;diffusion_pytorch_model.bin&quot; ) { :ok , scheduler } = Bumblebee . load_scheduler ( { :hf , repository_id , subdir : &quot;scheduler&quot; } ) { :ok , featurizer } = Bumblebee . load_featurizer ( { :hf , repository_id , subdir : &quot;feature_extractor&quot; } ) { :ok , safety_checker } = Bumblebee . load_model ( { :hf , repository_id , subdir : &quot;safety_checker&quot; } ) :ok Note: some checkpoints, such as runwayml/stable-diffusion-v1-5 , require a license agreement. In those cases, sign up on Hugging Face, accept the license on the repository page, generate an access token in the settings and add it to the repository specification via :auth_token . You can use Livebook secrets to pass the token securely. With all the models loaded, we can now configure a serving implementation of the text-to-image task. serving = Bumblebee.Diffusion.StableDiffusion . text_to_image ( clip , unet , vae , tokenizer , scheduler , num_steps : 20 , num_images_per_prompt : 2 , safety_checker : safety_checker , safety_checker_featurizer : featurizer , compile : [ batch_size : 1 , sequence_length : 60 ] , defn_options : [ compiler : EXLA ] ) prompt_input = Kino.Input . text ( &quot;Prompt&quot; , default : &quot;numbat, forest, high quality, detailed, digital art&quot; ) negative_prompt_input = Kino.Input . text ( &quot;Negative Prompt&quot; , default : &quot;darkness, rainy, foggy&quot; ) Kino.Layout . grid ( [ prompt_input , negative_prompt_input ] ) We are ready to generate images! prompt = Kino.Input . read ( prompt_input ) negative_prompt = Kino.Input . read ( negative_prompt_input ) output = Nx.Serving . run ( serving , %{ prompt : prompt , negative_prompt : negative_prompt } ) for result &lt;- output . results do Kino.Image . new ( result . image ) end |&gt; Kino.Layout . grid ( columns : 2 ) To achieve a better quality you can increase the number of steps and images.","ref":"stable_diffusion.html#text-to-image","title":"Stable Diffusion - Text to image","type":"extras"},{"doc":"Mix . install ( [ { :bumblebee , &quot;~&gt; 0.3.0&quot; } , { :axon , &quot;~&gt; 0.5.1&quot; } , { :nx , &quot;~&gt; 0.5.1&quot; } , { :exla , &quot;~&gt; 0.5.1&quot; } , { :explorer , &quot;~&gt; 0.5.0&quot; } ] ) :ok","ref":"fine_tuning.html","title":"Fine-tuning","type":"extras"},{"doc":"Nx . default_backend ( EXLA.Backend ) { Nx.BinaryBackend , [ ] } Fine-tuning is the process of specializing the parameters in a pre-trained model to a specific task. Large-language models such as BERT train on a generic langauge-modeling task which makes them powerful at extracting features from text. Despite their power, you often still need to train them on a downstream task. This example demonstrates how to use Bumblebee and Axon to fine-tune a pre-trained Bert model to classify Yelp reviews into classes of 1-5 stars. This example is based on Fine-tune a pretrained model from Huggingface. You'll need to first download the Yelp Reviews dataset ( download ). Once downloaded, extract it to a directory of your choosing and you're ready to go!","ref":"fine_tuning.html#introduction","title":"Fine-tuning - Introduction","type":"extras"},{"doc":"We'll start by loading a pre-trained model and tokenizer; however, we'll initialize the model to have an untrained sequence classification head. Reviews in the dataset can have anywhere from 1 to 5 stars, which means we need 5 labels in our sequence classification head. We can change the default configuration by loading the model spec with Bumblebee.load_spec/2 and making changes to spec properties with Bumblebee.configure/2 . The pre-trained model we'll be using is bert-base-cased ; however, you can use any of the supported models from the HuggingFace Hub. { :ok , spec } = Bumblebee . load_spec ( { :hf , &quot;bert-base-cased&quot; } , architecture : :for_sequence_classification ) spec = Bumblebee . configure ( spec , num_labels : 5 ) { :ok , model } = Bumblebee . load_model ( { :hf , &quot;bert-base-cased&quot; } , spec : spec ) { :ok , tokenizer } = Bumblebee . load_tokenizer ( { :hf , &quot;bert-base-cased&quot; } ) 14 : 41 : 33.314 [ info ] TfrtCpuClient created . 14 : 41 : 33.820 [ debug ] the following parameters were missing : * sequence_classification_head . output . kernel * sequence_classification_head . output . bias 14 : 41 : 33.820 [ debug ] the following PyTorch parameters were unused : * cls . predictions . bias * cls . predictions . decoder . weight * cls . predictions . transform . LayerNorm . beta * cls . predictions . transform . LayerNorm . gamma * cls . predictions . transform . dense . bias * cls . predictions . transform . dense . weight * cls . seq_relationship . bias * cls . seq_relationship . weight { :ok , % Bumblebee.Text.BertTokenizer { tokenizer : # Tokenizers.Tokenizer &lt; [ vocab_size : 28996 , continuing_subword_prefix : &quot;##&quot; , max_input_chars_per_word : 100 , model_type : &quot;bpe&quot; , unk_token : &quot;[UNK]&quot; ] &gt; , special_tokens : %{ cls : &quot;[CLS]&quot; , mask : &quot;[MASK]&quot; , pad : &quot;[PAD]&quot; , sep : &quot;[SEP]&quot; , unk : &quot;[UNK]&quot; } } }","ref":"fine_tuning.html#load-a-model","title":"Fine-tuning - Load a model","type":"extras"},{"doc":"With the models downloaded and ready to go, you need to prepare the dataset. The downloaded dataset is a CSV. You can use the Explorer library to quickly load the CSV into a DataFrame. Once the data is loaded, you need to convert raw text to tokens and the raw labels to tensors. Additionally, you need to convert the DataFrame to a Stream consisting of tuples: {tokenized, labels} - that is the form expected by Axon's training API. defmodule Yelp do def load ( path , tokenizer , opts \\\\ [ ] ) do path |&gt; Explorer.DataFrame . from_csv! ( header : false ) |&gt; Explorer.DataFrame . rename ( [ &quot;label&quot; , &quot;text&quot; ] ) |&gt; stream ( ) |&gt; tokenize_and_batch ( tokenizer , opts [ :batch_size ] , opts [ :sequence_length ] ) end def stream ( df ) do xs = df [ &quot;text&quot; ] ys = df [ &quot;label&quot; ] xs |&gt; Explorer.Series . to_enum ( ) |&gt; Stream . zip ( Explorer.Series . to_enum ( ys ) ) end def tokenize_and_batch ( stream , tokenizer , batch_size , sequence_length ) do stream |&gt; Stream . chunk_every ( batch_size ) |&gt; Stream . map ( fn batch -&gt; { text , labels } = Enum . unzip ( batch ) tokenized = Bumblebee . apply_tokenizer ( tokenizer , text , length : sequence_length ) { tokenized , Nx . stack ( labels ) } end ) end end { :module , Yelp , &lt;&lt; 70 , 79 , 82 , 49 , 0 , 0 , 13 , ... &gt;&gt; , { :tokenize_and_batch , 4 } } Now you can use the Yelp.load/2 function to load a training set and a testing set: batch_size = 32 sequence_length = 64 train_data = Yelp . load ( &quot;~/yelp/yelp_review_full_csv/train.csv&quot; , tokenizer , batch_size : batch_size , sequence_length : sequence_length ) test_data = Yelp . load ( &quot;~/yelp/yelp_review_full_csv/test.csv&quot; , tokenizer , batch_size : batch_size , sequence_length : sequence_length ) # Stream &lt; [ enum : # Stream &lt; [ enum : # Function &lt; 73.124013645 / 2 in Stream . zip_with / 2 &gt; , funs : [ # Function &lt; 3.124013645 / 1 in Stream . chunk_while / 4 &gt; ] ] &gt; , funs : [ # Function &lt; 48.124013645 / 1 in Stream . map / 2 &gt; ] ] &gt; You can see what a single batch looks like by grabbing 1 from the stream: Enum . take ( train_data , 1 ) [ { %{ &quot;attention_mask&quot; =&gt; # Nx.Tensor &lt; s64 [ 32 ] [ 64 ] EXLA.Backend &lt; host : 0 , 0.801663575 . 1558315030.66545 &gt; [ [ 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , ... ] , ... ] &gt; , &quot;input_ids&quot; =&gt; # Nx.Tensor &lt; s64 [ 32 ] [ 64 ] EXLA.Backend &lt; host : 0 , 0.801663575 . 1558315030.66544 &gt; [ [ 101 , 173 , 1197 , 119 , 2284 , 2953 , 3272 , 1917 , 178 , 1440 , 1111 , 1107 , 170 , 1704 , 22351 , 119 , 1119 , 112 , 188 , 3505 , 1105 , 3123 , 1106 , 2037 , 1106 , 1443 , 1217 , 10063 , 4404 , 132 , 1119 , 112 , 188 , 1579 , 1113 , 1159 , 1107 , 3195 , 1117 , 4420 , 132 , 1119 , 112 , 188 , 6559 , 1114 , ... ] , ... ] &gt; , &quot;token_type_ids&quot; =&gt; # Nx.Tensor &lt; s64 [ 32 ] [ 64 ] EXLA.Backend &lt; host : 0 , 0.801663575 . 1558315030.66546 &gt; [ [ 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , ... ] , ... ] &gt; } , # Nx.Tensor &lt; s64 [ 32 ] EXLA.Backend &lt; host : 0 , 0.801663575 . 1558315028.66360 &gt; [ 5 , 2 , 4 , 4 , 1 , 5 , 5 , 1 , 2 , 3 , 1 , 1 , 4 , 2 , 5 , 5 , 5 , 5 , 5 , 5 , 4 , 3 , 2 , 5 , 1 , 1 , 1 , 2 , 2 , 4 , 2 , 2 ] &gt; } ] The dataset is rather large for CPU training, so we'll just train a small subset (250 training batches and 50 testing batches): train_data = Enum . take ( train_data , 250 ) test_data = Enum . take ( test_data , 50 ) :ok :ok","ref":"fine_tuning.html#prepare-a-dataset","title":"Fine-tuning - Prepare a dataset","type":"extras"},{"doc":"Now we can go about training the model! First, we need to extract the Axon model and parameters from the Bumblebee model map: %{ model : model , params : params } = model model # Axon &lt; inputs : %{ &quot;attention_head_mask&quot; =&gt; { 12 , 12 } , &quot;attention_mask&quot; =&gt; { nil , nil } , &quot;input_ids&quot; =&gt; { nil , nil } , &quot;position_ids&quot; =&gt; { nil , nil } , &quot;token_type_ids&quot; =&gt; { nil , nil } } outputs : &quot;container_37&quot; nodes : 790 &gt; The Axon model actually outputs a map with :logits , :hidden_states , and :attentions . You can see this by using Axon.get_output_shape/2 with an input. This method symbolically executes the graph and gets the resulting shapes: [ { input , _ } ] = Enum . take ( train_data , 1 ) Axon . get_output_shape ( model , input ) %{ attentions : # Axon.None &lt; ... &gt; , hidden_states : # Axon.None &lt; ... &gt; , logits : { 32 , 5 } } For training, we only care about the :logits key, so we'll extract that by attaching an Axon.nx/2 layer to the model: logits_model = Axon . nx ( model , &amp; &amp;1 . logits ) # Axon &lt; inputs : %{ &quot;attention_head_mask&quot; =&gt; { 12 , 12 } , &quot;attention_mask&quot; =&gt; { nil , nil } , &quot;input_ids&quot; =&gt; { nil , nil } , &quot;position_ids&quot; =&gt; { nil , nil } , &quot;token_type_ids&quot; =&gt; { nil , nil } } outputs : &quot;nx_0&quot; nodes : 791 &gt; Now we can declare our training loop. You can construct Axon training loops using the Axon.Loop.trainer/3 factory method with a model, loss function, and optimizer. We'll also adjust the log-settings to more frequently log metrics to standard out: loss = &amp; Axon.Losses . categorical_cross_entropy ( &amp;1 , &amp;2 , reduction : :mean , from_logits : true , sparse : true ) optimizer = Axon.Optimizers . adam ( 5.0e-5 ) loop = Axon.Loop . trainer ( logits_model , loss , optimizer , log : 1 ) # Axon.Loop &lt; metrics : %{ &quot;loss&quot; =&gt; { # Function &lt; 11.3813108 / 3 in Axon.Metrics . running_average / 1 &gt; , # Function &lt; 41.3316493 / 2 in :erl_eval . expr / 6 &gt; } } , handlers : %{ completed : [ ] , epoch_completed : [ { # Function &lt; 27.14409478 / 1 in Axon.Loop . log / 3 &gt; , # Function &lt; 6.14409478 / 2 in Axon.Loop . build_filter_fn / 1 &gt; } ] , epoch_halted : [ ] , epoch_started : [ ] , halted : [ ] , iteration_completed : [ { # Function &lt; 27.14409478 / 1 in Axon.Loop . log / 3 &gt; , # Function &lt; 64.14409478 / 2 in Axon.Loop . build_filter_fn / 1 &gt; } ] , iteration_started : [ ] , started : [ ] } , ... &gt; The call to trainer just returns a data structure. In Axon, we manipulate this data structure to control different parts of the loop. For example, you can attach metrics: accuracy = &amp; Axon.Metrics . accuracy ( &amp;1 , &amp;2 , from_logits : true , sparse : true ) loop = Axon.Loop . metric ( loop , accuracy , &quot;accuracy&quot; ) # Axon.Loop &lt; metrics : %{ &quot;accuracy&quot; =&gt; { # Function &lt; 11.3813108 / 3 in Axon.Metrics . running_average / 1 &gt; , # Function &lt; 41.3316493 / 2 in :erl_eval . expr / 6 &gt; } , &quot;loss&quot; =&gt; { # Function &lt; 11.3813108 / 3 in Axon.Metrics . running_average / 1 &gt; , # Function &lt; 41.3316493 / 2 in :erl_eval . expr / 6 &gt; } } , handlers : %{ completed : [ ] , epoch_completed : [ { # Function &lt; 27.14409478 / 1 in Axon.Loop . log / 3 &gt; , # Function &lt; 6.14409478 / 2 in Axon.Loop . build_filter_fn / 1 &gt; } ] , epoch_halted : [ ] , epoch_started : [ ] , halted : [ ] , iteration_completed : [ { # Function &lt; 27.14409478 / 1 in Axon.Loop . log / 3 &gt; , # Function &lt; 64.14409478 / 2 in Axon.Loop . build_filter_fn / 1 &gt; } ] , iteration_started : [ ] , started : [ ] } , ... &gt; And you can attach event handlers to do certain things, such as serialize the loop state at regular intervals so you don't lose your progress: loop = Axon.Loop . checkpoint ( loop , event : :epoch_completed ) # Axon.Loop &lt; metrics : %{ &quot;accuracy&quot; =&gt; { # Function &lt; 11.3813108 / 3 in Axon.Metrics . running_average / 1 &gt; , # Function &lt; 41.3316493 / 2 in :erl_eval . expr / 6 &gt; } , &quot;loss&quot; =&gt; { # Function &lt; 11.3813108 / 3 in Axon.Metrics . running_average / 1 &gt; , # Function &lt; 41.3316493 / 2 in :erl_eval . expr / 6 &gt; } } , handlers : %{ completed : [ ] , epoch_completed : [ { # Function &lt; 17.14409478 / 1 in Axon.Loop . checkpoint / 2 &gt; , # Function &lt; 6.14409478 / 2 in Axon.Loop . build_filter_fn / 1 &gt; } , { # Function &lt; 27.14409478 / 1 in Axon.Loop . log / 3 &gt; , # Function &lt; 6.14409478 / 2 in Axon.Loop . build_filter_fn / 1 &gt; } ] , epoch_halted : [ ] , epoch_started : [ ] , halted : [ ] , iteration_completed : [ { # Function &lt; 27.14409478 / 1 in Axon.Loop . log / 3 &gt; , # Function &lt; 64.14409478 / 2 in Axon.Loop . build_filter_fn / 1 &gt; } ] , iteration_started : [ ] , started : [ ] } , ... &gt; To run the loop, you just need to call Axon.Loop.run/4 . Axon.Loop.run/4 takes a loop, input data, and any initial state (in this case initial parameters). You can kind of think of Axon.Loop.run/4 as an Enum.reduce/3 . It takes data, an accumulator, and a function - which map to Loop.run/4 input data, initial state, and the actual loop data structure. You'll commonly see loops written out in long chains using Elixir's |&gt; operator, like this: trained_model_state = logits_model |&gt; Axon.Loop . trainer ( loss , optimizer , log : 1 ) |&gt; Axon.Loop . metric ( accuracy , &quot;accuracy&quot; ) |&gt; Axon.Loop . checkpoint ( event : :epoch_completed ) |&gt; Axon.Loop . run ( train_data , params , epochs : 3 , compiler : EXLA , strict? : false ) :ok 02 : 46 : 02.170 [ debug ] Forwarding options : [ compiler : EXLA ] to JIT compiler Epoch : 0 , Batch : 249 , accuracy : 0.3462500 loss : 1.2216607 Epoch : 1 , Batch : 249 , accuracy : 0.5186251 loss : 1.0558304 Epoch : 2 , Batch : 249 , accuracy : 0.6236249 loss : 0.9317472 :ok","ref":"fine_tuning.html#train-the-model","title":"Fine-tuning - Train the model","type":"extras"},{"doc":"The training loop returns the final model state after training over your dataset for the given number of epochs. Axon uses the same Axon.Loop API to create evaluation loops as well. You can create one with the Axon.Loop.evaluator/1 factory, instrument it with metrics, and run it on your data with your trained model state: logits_model |&gt; Axon.Loop . evaluator ( ) |&gt; Axon.Loop . metric ( accuracy , &quot;accuracy&quot; ) |&gt; Axon.Loop . run ( test_data , trained_model_state , compiler : EXLA ) Batch : 49 , accuracy : 0.3675000 %{ 0 =&gt; %{ &quot;accuracy&quot; =&gt; # Nx.Tensor &lt; f32 EXLA.Backend &lt; host : 0 , 0.446408219 . 3911319572.169449 &gt; 0.36750003695487976 &gt; } }","ref":"fine_tuning.html#evaluating-the-model","title":"Fine-tuning - Evaluating the model","type":"extras"}]